The data included here is from the NCAR POP2 (active ocean/sea ice) model. The model was forced with 5 cycles of the CORE data (from 1948-2007). Each term requested is provided in 5 files, one for each cycle; thus, each file has 720 time steps. All files should have the same missing (land) value, 9.96921e+36f. The following describes each set of data requested.


1. MODEL GEOMETRY

The file titled model_geometry.nc includes the following variables from POP2 output:

	1. TLONG = tracer cell latitude
	2. TLAT = tracer cell longitude
	3. TAREA = horizontal area (m^2) of grid cells, does not change with depth
	4. z_w = depth from surface to midpoint of layer (m)
	5. z_t = depth from surface to top of layer (m)
	6. VOLUME = volume of tracer cells (calculated TAREA*layer thickness) (m^3), land value = 0
	
2. SEA SURFACE HEIGHT AND BOTTOM PRESSURE

	1. SSH_Annually = sea surface height output by model (annual averages) (cm)
	2. SSH_Monthly = sea surface height output by model (monthly averages) (cm)
	3. Pbottom_Annually = estimated bottom pressure (annual averages) (Pa)
                Calculated from the sea-surface pressure (CORE forcing-NCEP) and ocean 3-D density distribution (RHO), P_bot=P_atm+rho*g*h. 
	4. Pbottom_Monthly = estimated bottom pressure (monthly averages) (Pa)
                Calculated from the sea-surface pressure (CORE forcing-NCEP) and ocean 3-D density distribution (RHO), P_bot=P_atm+rho*g*h.
	
3. STERIC EFFECTS

	1. TEMP_Annually = 3D TEMP field output by model (annual averages) (degC)
	2. SALT_Annually = 3D SALT field output by model (annual averages) (g/kg)
	
4. BOUNDARY FORCING
	
	1. curl_Monthly = wind stress curl calculated from TAUX and TAUY output by model 
		(monthly averages) (dy/m^3)
	
	2. SHF_Monthly = net surface heat flux output by the model (monthly averages) (W/m^2)
		
		The model calculates SHF from the following variables: net shortwave, net longwave,
		sensible heat, latent heat, melt flux, snow flux, heat flux due to ice formation, 
		and ice runoff heat flux. The terms from the ocean model used for these are: SHF_QSW, 
		(LWDN_F,LWUP_F), SENH_F, EVAP_F, MELT_F, SNOW_F, QFLUX, and IOFF_F.
		
	3. salt_flux_Monthly = net surface salt flux (averaged monthly) (kg/m^2/s)
	
		Calculated from the ice-ocean interaction and salt restoring terms output
		by the model. These terms are: SALT_F and SFWF_WRST.
	
	4. mass_flux_Monthly = net mass flux from precipitation, evaporation, rivers, and sea 
		ice melt/formation. (monthly averages) (kg/m^2/s)
		
		This was calculated from the following variables output by the model: 
		PREC_F, EVAP_F, ROFF, MELT_F.
		
	5. There is no geothermal heating in the POP2 model.

!
subroutine open_cdf(ncid,filename,read_only)
  !
  use counters_netcdf_jfl
  use definitions_netcdf_jfl
  !
  ! open existing netcdf file and return its ID number
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) filename
  logical, optional :: read_only
  !
  ! local
  !
  integer status
  !
  if(present(read_only)) then
     if(read_only) then
        status = nf_open(filename,NF_NOWRITE,ncid)
        if(status.ne.nf_noerr) call handle_err(status)
     else
        status = nf_open(filename,NF_WRITE,ncid)
        if(status.ne.nf_noerr) call handle_err(status)
     endif
  else
     status = nf_open(filename,NF_WRITE,ncid)
     if(status.ne.nf_noerr) call handle_err(status)
  endif
  !
  ! make sure the file ID is OK
  !
  if(ncid.lt.0) then
     print *,'Problem opening ',filename,' ncid = ',ncid
     call abort()
  else
     file_counter = file_counter + 1
  endif
  !
  nc_filename(file_counter) = filename
  !
  return
end subroutine open_cdf
!
subroutine create_cdf(ncid,filename)
  !
  use counters_netcdf_jfl
  use definitions_netcdf_jfl
  !
  ! create new netcdf file and return its ID number
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) filename
  !
  ! local
  !
  integer status
  !
  status = nf_create(filename,NF_CLOBBER,ncid)
  if(status.ne.nf_noerr) call handle_err(status)
  !
  ! make sure the file ID is OK
  !
  if(ncid.le.0) then
     print *,'Problem opening ',filename,' ncid = ',ncid
     call abort()
  else
     file_counter = file_counter + 1
  endif
  !
  nc_filename(file_counter) = filename
  !
  return
end subroutine create_cdf
!
subroutine end_def(ncid)
  !
  ! end definition mode for netcdf file
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! argument
  !
  integer ncid
  !
  ! local
  !
  integer status
  !
  status = nf_enddef(ncid)
  if(status.ne.nf_noerr) call handle_err(status)
  !
  return
end subroutine end_def
!
subroutine close_cdf(ncid)
  !
  ! create new netcdf file and return its ID number
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  !
  ! local
  !
  integer status
  !
  status = nf_close(ncid)
  if(status.ne.nf_noerr) call handle_err(status)
  !
  return
end subroutine close_cdf
!
subroutine def_dim(ncid,dim_name,dim_length)
  !
  ! define dimension in netcdf file
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid,dim_length
  character(*) dim_name
  !
  ! local
  !
  integer status,dim_id
  !
  if(dim_length.gt.0) then
     status = nf_def_dim(ncid,dim_name,dim_length  ,dim_id)
  else
     status = nf_def_dim(ncid,dim_name,nf_unlimited,dim_id)
  endif
  if(status.ne.nf_noerr) call handle_err(status)
  !
  dim_counter = dim_counter + 1
  if(dim_counter.gt.dim_max) then
     print *,'maximum number of dimensions ',dim_max
     print *,'is reached, stopping'
     stop
  endif
  dim_info(dim_counter)%name      = dim_name
  dim_info(dim_counter)%id        = dim_id
  dim_info(dim_counter)%length    = dim_length
  dim_info(dim_counter)%file_name = nc_filename(file_counter)
  !
  return
end subroutine def_dim
!
subroutine def_var(ncid,var_name,format,type,units,long_name)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*)::var_name,format,type
  character(*),optional :: units,long_name
  !
  ! local
  !
  integer i,j,n
  integer status,xtype,nvdims,var_id
  integer, dimension(:), allocatable :: vdims ,length
  character*1  :: comma = ','
  character*32 :: work
  integer pos1,pos2,pos3,position(100),ncomma
  !
  ! remove possible comma at the end of format
  !
  if(format(len(format):len(format)).eq.comma) then
     format(len(format):len(format)) = ' '
  endif
  !
  ! special case for mif variables
  !
  if(format(:len_trim(format)).eq.'mif') then
     if(type.eq.'character') then
        nvdims = 3
        allocate(vdims (nvdims))
        allocate(length(nvdims))
        do i=1,dim_counter
           if(dim_info(i)%name.eq.'mif1') then
              vdims (2) = dim_info(i)%id
              length(2) = dim_info(i)%length
           elseif(dim_info(i)%name.eq.'mif2') then
              vdims (3) = dim_info(i)%id
              length(3) = dim_info(i)%length
           elseif(dim_info(i)%name.eq.'mif3') then
              vdims (1) = dim_info(i)%id
              length(1) = dim_info(i)%length
           endif
        end do
     else
        nvdims = 2
        allocate(vdims (nvdims))
        allocate(length(nvdims))
        do i=1,dim_counter
           if(dim_info(i)%name.eq.'mif1') then
              vdims (1) = dim_info(i)%id
              length(1) = dim_info(i)%length
           elseif(dim_info(i)%name.eq.'mif2') then
              vdims (2) = dim_info(i)%id
              length(2) = dim_info(i)%length
           endif
        end do
     endif
  else
     !
     ! default case
     !
     if(len_trim(format).eq.0) then
        print *,'problem with defining ',var_name
        print *,'no format defined'
        stop
     endif
     !
     ! find position of commas
     !
     ncomma = 0
     do n=1,len_trim(format)
        if(format(n:n).eq.comma) then
           ncomma = ncomma + 1
           position(ncomma) = n
        endif
     end do
     ncomma = ncomma + 1
     position(ncomma) = len_trim(format) + 1
     !
     nvdims = ncomma
     allocate(vdims (nvdims))
     allocate(length(nvdims))
     vdims = -1
     !
     pos1 = 1
     do i=1,nvdims
        pos2 = position(i) - 1
        pos3 = pos2 - pos1 + 1
        work = ' '
        work(:pos3) = format(pos1:pos2)
        pos1 = pos2 + 2
        do j=1,dim_counter
           if(dim_info(j)%name.eq.work(:pos3).and.&
                dim_info(j)%file_name.eq.nc_filename(file_counter)) then
              vdims (i) = dim_info(j)%id
              length(i) = dim_info(j)%length
              exit
           endif
        end do
     end do
     !
  endif
  !
  ! define external type
  !
  if(type.eq.'integer'  ) xtype = nf_int
  if(type.eq.'float'    ) xtype = nf_float
  if(type.eq.'double'   ) xtype = nf_double
  if(type.eq.'character') xtype = nf_char
  !
  ! define variable
  !
  status = nf_def_var(ncid,var_name,xtype,nvdims,vdims,var_id)
  if(status.ne.nf_noerr) call handle_err(status)
  !
  ! declare attributes
  !
  if(present(long_name)) then
     status = nf_put_att_text(ncid,var_id,'long_name'&
          ,len(long_name),long_name)
     if(status.ne.nf_noerr) call handle_err(status)
  endif
  !
  if(present(units)) then
     status = nf_put_att_text(ncid,var_id,'units'&
          ,len(units),units)
     if(status.ne.nf_noerr) call handle_err(status)
  endif
  !
  ! store information
  !
  var_counter = var_counter + 1
  if(var_counter.gt.var_max) then
     print *,'maximum number of variables ',var_max
     print *,'is reached, stopping'
     stop
  endif
  var_info(var_counter)%name      = var_name
  var_info(var_counter)%format    = format
  var_info(var_counter)%type      = type
  var_info(var_counter)%id        = var_id
  var_info(var_counter)%file_name = nc_filename(file_counter)
  var_info(var_counter)%nvdims    = nvdims
  do i=1,nvdims
     var_info(var_counter)%vdims(i) = length(i)
  end do
  !
  deallocate(vdims )
  deallocate(length)
  !
  return
end subroutine def_var
!
subroutine get_dims(ncid)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  !
  ! local
  !
  integer n,num_dim
  integer length
  integer status
  character*32 name
  !
  status = nf_inq_ndims(ncid,num_dim)
  if(status.ne.nf_noerr) call handle_err(status)
  !
  if(num_dim.gt.dim_max) then
     print *,'number of dimensions found = ',num_dim
     print *,'maximum allowed            = ',dim_max
     stop
  endif
  !
  do n=1,num_dim
     name = ' '
     status = nf_inq_dim(ncid,n,name,length)
     if(status.ne.nf_noerr) call handle_err(status)
     dim_counter = dim_counter + 1
     dim_info(dim_counter)%id        = n
     dim_info(dim_counter)%name      = name
     dim_info(dim_counter)%length    = length
     dim_info(dim_counter)%file_name = nc_filename(file_counter)
  end do
  !
  return
end subroutine get_dims
!
subroutine get_vars(ncid)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  !
  ! local
  !
  integer i,j,n,num_var
  integer status
  integer xtype,nvdims,length,natts
  integer pos1,pos2
  integer, dimension(:), allocatable :: dim_id
  real::missing_value,FillValue
  integer::int_missing_value,int_FillValue
  character(len=256)::name,aname,units
  character*1 :: comma = ','
  !
  status = nf_inq_nvars(ncid,num_var)
  if(status.ne.nf_noerr) call handle_err(status)
  !
  if(num_var.gt.var_max) then
     print *,'number of variables found = ',num_var
     print *,'maximum allowed           = ',var_max
     stop
  endif
  !
  do n=1,num_var
     !
     name          = ' '
     units         = ' '
     missing_value = -1.e32
     FillValue     = -1.e32
     int_missing_value = -1.e9
     int_FillValue     = -1.e9
     status = nf_inq_varname(ncid,n,name)
     if(status.ne.nf_noerr) call handle_err(status)
     !
     status = nf_inq_vartype(ncid,n,xtype)
     if(status.ne.nf_noerr) call handle_err(status)
     !
     status = nf_inq_varndims(ncid,n,nvdims)
     if(status.ne.nf_noerr) call handle_err(status)
     !
     status = nf_inq_varnatts(ncid,n,natts)
     if(status.ne.nf_noerr) call handle_err(status)
     if (natts /= 0) then
        do i=1,natts
           status=nf_inq_attname(ncid,n,i,aname)
           if(status.ne.nf_noerr) call handle_err(status)
           if (trim(aname) == 'units') then
              status = nf_get_att_text(ncid,n,aname,units)
              if(status.ne.nf_noerr) call handle_err(status)
           endif
           if (trim(aname) == 'missing_value') then
              if (xtype == nf_float) then
                 status = nf_get_att_real(ncid,n,aname,missing_value)
                 if(status.ne.nf_noerr) call handle_err(status)
              elseif (xtype == nf_int) then
                 status = nf_get_att_int(ncid,n,aname,int_missing_value)
                 if(status.ne.nf_noerr) call handle_err(status)
              endif
           endif
           if (trim(aname) == '_FillValue') then
              if (xtype == nf_float) then
                 status = nf_get_att_real(ncid,n,aname,FillValue)
                 if(status.ne.nf_noerr) call handle_err(status)
              elseif (xtype == nf_int) then
                 status = nf_get_att_int(ncid,n,aname,int_FillValue)
                 if(status.ne.nf_noerr) call handle_err(status)
              endif
           endif
        enddo
     endif
     !
     allocate(dim_id(nvdims))
     status = nf_inq_vardimid(ncid,n,dim_id)
     if(status.ne.nf_noerr) call handle_err(status)
     !
     var_counter = var_counter + 1
     var_info(var_counter)%id                = n
     var_info(var_counter)%name              = name
     var_info(var_counter)%units             = units
     var_info(var_counter)%missing_value     = missing_value
     var_info(var_counter)%FillValue         = FillValue
     var_info(var_counter)%int_missing_value = int_missing_value
     var_info(var_counter)%int_FillValue     = int_FillValue
     var_info(var_counter)%file_name         = nc_filename(file_counter)
     select case ( xtype )
     case ( nf_int )
        var_info(var_counter)%type = 'integer'
     case ( nf_float )
        var_info(var_counter)%type = 'float'
     case ( nf_double )
        var_info(var_counter)%type = 'double'
     case ( nf_char )
        var_info(var_counter)%type = 'character'
     end select
     var_info(var_counter)%nvdims = nvdims
     pos1 = 1
     pos2 = 1
     do i=1,nvdims
        do j=1,dim_counter
           if((dim_info(j)%id.eq.dim_id(i)).and.&
                (dim_info(j)%file_name.eq.nc_filename(file_counter))) then
              length = dim_info(j)%length
              name = ' '
              name = dim_info(j)%name
              exit
           endif
        end do
        var_info(var_counter)%vdims(i) = length
        pos2 = pos1 + len_trim(name) - 1
        var_info(var_counter)%format(pos1:pos2)&
             = name(:len_trim(name))
        pos2 = pos2 + 1
        var_info(var_counter)%format(pos2:pos2) = comma
        pos1 = pos2 + 1
     end do
     !
     ! remove last comma
     !
     var_info(var_counter)%format(pos2:pos2) = ' '
     !
     ! deallocate memory
     !
     deallocate(dim_id)
     !
  end do
  !
  return
end subroutine get_vars
!
subroutine write_var_i_0(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  integer array
  !
  include 'put_var_int.inc'
  !
  return
end subroutine write_var_i_0
!
subroutine write_var_i_1(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  integer array(:)
  !
  include 'put_var_int.inc'
  !
  return
end subroutine write_var_i_1
!
subroutine write_var_i_2(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  integer array(:,:)
  !
  include 'put_var_int.inc'
  !
  return
end subroutine write_var_i_2
!
subroutine write_var_i_3(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  integer array(:,:,:)
  !
  include 'put_var_int.inc'
  !
  return
end subroutine write_var_i_3
!
subroutine write_var_f_0(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array
  !
  include 'put_var_real.inc'
  !
  return
end subroutine write_var_f_0
!
subroutine write_var_f_1(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array(:)
  !
  include 'put_var_real.inc'
  !
  return
end subroutine write_var_f_1
!
subroutine write_var_f_2(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array(:,:)
  !
  include 'put_var_real.inc'
  !
  return
end subroutine write_var_f_2
!
subroutine write_var_f_3(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array(:,:,:)
  !
  include 'put_var_real.inc'
  !
  return
end subroutine write_var_f_3
!
subroutine write_var_f_4(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array(:,:,:,:)
  !
  include 'put_var_real.inc'
  !
  return
end subroutine write_var_f_4
!
subroutine write_var_d_0(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real*8 array
  !
  include 'put_var_dble.inc'
  !
  return
end subroutine write_var_d_0
!
subroutine write_var_d_1(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real*8 array(:)
  !
  include 'put_var_dble.inc'
  !
  return
end subroutine write_var_d_1
!
subroutine write_var_d_2(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real*8 array(:,:)
  !
  include 'put_var_dble.inc'
  !
  return
end subroutine write_var_d_2
!
subroutine write_var_d_3(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real*8 array(:,:,:)
  !
  include 'put_var_dble.inc'
  !
  return
end subroutine write_var_d_3
!
subroutine write_var_c_0(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) array
  !
  include 'put_var_text.inc'
  !
  return
end subroutine write_var_c_0
!
subroutine write_var_c_1(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) array(:)
  !
  include 'put_var_text.inc'
  !
  return
end subroutine write_var_c_1
!
subroutine write_var_c_2(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) array(:,:)
  !
  include 'put_var_text.inc'
  !
  return
end subroutine write_var_c_2
!
subroutine read_var_i_0(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  integer array
  !
  include 'get_var_int.inc'
  !
  return
end subroutine read_var_i_0
!
subroutine read_var_i_1(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  integer array(:)
  !
  include 'get_var_int.inc'
  !
  return
end subroutine read_var_i_1
!
subroutine read_var_i8_1(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  integer*8 array(:)
  !
  include 'get_var_int.inc'
  !
  return
end subroutine read_var_i8_1
!
subroutine read_var_i_2(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  integer array(:,:)
  !
  include 'get_var_int.inc'
  !
  return
end subroutine read_var_i_2
!
subroutine read_var_i_3(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  integer array(:,:,:)
  !
  include 'get_var_int.inc'
  !
  return
end subroutine read_var_i_3
!
subroutine read_var_f_0(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array
  !
  include 'get_var_real.inc'
  !
  return
end subroutine read_var_f_0
!
subroutine read_var_f_1(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array(:)
  !
  include 'get_var_real.inc'
  !
  return
end subroutine read_var_f_1
!
subroutine read_var_f_2(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array(:,:)
  !
  include 'get_var_real.inc'
  !
  return
end subroutine read_var_f_2
!
subroutine read_var_f_3(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array(:,:,:)
  !
  include 'get_var_real.inc'
  !
  return
end subroutine read_var_f_3
!
subroutine read_var_f_4(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  real array(:,:,:,:)
  !
  include 'get_var_real.inc'
  !
  return
end subroutine read_var_f_4
!
subroutine read_var_d_0(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  double precision array
  !
  include 'get_var_double.inc'
  !
  return
end subroutine read_var_d_0
!
subroutine read_var_d_1(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  double precision array(:)
  !
  include 'get_var_double.inc'
  !
  return
end subroutine read_var_d_1
!
subroutine read_var_d_2(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  double precision array(:,:)
  !
  include 'get_var_double.inc'
  !
  return
end subroutine read_var_d_2
!
subroutine read_var_d_3(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  double precision array(:,:,:)
  !
  include 'get_var_double.inc'
  !
  return
end subroutine read_var_d_3
!
subroutine read_var_d_4(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  double precision array(:,:,:,:)
  !
  include 'get_var_double.inc'
  !
  return
end subroutine read_var_d_4
!
subroutine read_var_c_0(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) array
  !
  include 'get_var_text.inc'
  !
  return
end subroutine read_var_c_0
!
subroutine read_var_c_1(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) array(:)
  !
  include 'get_var_text.inc'
  !
  return
end subroutine read_var_c_1
!
subroutine read_var_c_2(ncid,var_name,array)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) array(:,:)
  !
  include 'get_var_text.inc'
  !
  return
end subroutine read_var_c_2
subroutine write_att_text(ncid,var_name,att_name,att_val)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) att_name
  character(*) att_val
  !
  include 'put_att_text.inc'
  !
  return
end subroutine write_att_text
subroutine write_att_dble(ncid,var_name,att_name,att_val)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) att_name
  real*8       att_val
  !
  include 'put_att_dble.inc'
  !
  return
end subroutine write_att_dble
subroutine write_att_real(ncid,var_name,att_name,att_val)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) att_name
  real         att_val
  !
  include 'put_att_real.inc'
  !
  return
end subroutine write_att_real
subroutine write_att_int(ncid,var_name,att_name,att_val)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) att_name
  integer      att_val
  !
  include 'put_att_int.inc'
  !
  return
end subroutine write_att_int
!
subroutine read_att_text(ncid,var_name,att_name,att_val)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) att_name
  character(*) att_val
  !
  include 'get_att_text.inc'
  !
  return
end subroutine read_att_text
subroutine read_att_dble(ncid,var_name,att_name,att_val)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) att_name
  real*8       att_val
  !
  include 'get_att_dble.inc'
  !
  return
end subroutine read_att_dble
subroutine read_att_real(ncid,var_name,att_name,att_val)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) att_name
  real         att_val
  !
  include 'get_att_real.inc'
  !
  return
end subroutine read_att_real
subroutine read_att_int(ncid,var_name,att_name,att_val)
  !
  use definitions_netcdf_jfl
  use counters_netcdf_jfl
  !
  implicit none
  !
  include 'netcdf.inc'
  !
  ! arguments
  !
  integer ncid
  character(*) var_name
  character(*) att_name
  integer      att_val
  !
  include 'get_att_int.inc'
  !
  return
end subroutine read_att_int

program drive_ncinfo
  !
  ! Requirements:
  ! base state file;
  ! 1 to N input files;
  ! one auxiliary grid information file.
  ! All in netCDF format.
  !
  ! Argument one is "history" or "singlevar" - REQUIRED
  !
  ! Argument two is the "base" ocn file, ie, the one from which
  !  sea level change is to be computed
  ! If arg0 is "history", then
  !  Arguments 3 to N are the ocean files for which SLC should be computed (up to 1000 files)
  ! If arg0 is "singlevar", then
  !  Argument  3 is the TEMP data
  !  Argument  4 is the SALT data
  !  Argument  5 is the SSH data
  !  Argument  6 is the RHO data
  !
  ! Example history input file:
  ! history
  ! B06.62.ocn.1000-1100Ave.nc
  ! B06.62.ocn.1000.nc
  ! B06.62.ocn.1001.nc
  ! [...]
  ! B06.62.ocn.1099.nc
  ! B06.62.ocn.1100.nc
  !
  ! Example singlevar input file:
  ! singlevar
  ! b40.1850.track1.1deg.006.pop.h.0800-ave-1299.nc
  ! b40.20th.track1.1deg.008.pop.h.TEMP.192001-192912.nc
  ! b40.20th.track1.1deg.008.pop.h.SALT.192001-192912.nc
  ! b40.20th.track1.1deg.008.pop.h.SSH.192001-192912.nc
  ! b40.20th.track1.1deg.008.pop.h.RHO.192001-192912.nc
  implicit none
  !
  call get_ncinfo
end program drive_ncinfo
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine get_ncinfo
  !
  ! netCDF I/O subroutines
  !
  use counters_netcdf_jfl
  use interfaces_netcdf_jfl
  use definitions_netcdf_jfl
  use kinds_mod
  !
  implicit none
  !
  integer :: i,j,k,l,n,ier,length,io_status,ifile,nfile
  integer :: cnt_hist,cnt_temp,cnt_salt,cnt_ssh,cnt_rho
  integer :: cnt_base,cnt_grid,cnt_slc
  character(len=132) :: base_ocean_dataset
  character(len=132) :: temp_dataset,salt_dataset,rho_dataset,ssh_dataset
  character(len=132),dimension(1000) :: ocn_history
  !
  exists = .false.
  ishist = .false.
  issvar = .false.
  ispcm1 = .false.
  isccsm3 = .false.
  isccsm4 = .false.
  !
  read (*,*) dataset_type
  if (dataset_type == "history") then
     write(*,*) 'History file format data.'
     ishist = .true.
  elseif (dataset_type == "singlevar") then
     write(*,*) 'Single variable format data.'
     issvar = .true.
  else
     write(*,*) 'Unknown dataset format. DIE!'
     call abort()
  endif
  !
  read (*,*) base_ocean_dataset
  call check_exists(base_ocean_dataset)
  write(*,'(a,'' is base ocean state.'')') trim(base_ocean_dataset)
  !
  if (ishist) then
     io_status = 0
     ifile = 1
     do while (io_status == 0)
        read(*,*,iostat=io_status) ocn_history(ifile)
        if (io_status == 0) then
           call check_exists(ocn_history(ifile))
           ifile = ifile + 1
        endif
     enddo
     nfile = ifile - 1
  endif
  if (issvar) then
     read(*,*) temp_dataset
     read(*,*) salt_dataset
     read(*,*) ssh_dataset
     read(*,*) rho_dataset
     call check_exists(temp_dataset)
     call check_exists(salt_dataset)
     call check_exists(ssh_dataset)
     call check_exists(rho_dataset)
  endif
  !
  ! Get base ocean data
  !
  call open_cdf(ncid_base,trim(base_ocean_dataset),.true.)
  call get_dims(ncid_base)
  call get_vars(ncid_base)
  !
  ! Get base ocean dimensions
  !
  do n=1,dim_counter
     length = len_trim(dim_info(n)%name)
     if((dim_info(n)%name(:length).eq.'lat').or.(dim_info(n)%name(:length).eq.'nlat')) then
        nlat_base = dim_info(n)%length
     elseif((dim_info(n)%name(:length).eq.'lon').or.(dim_info(n)%name(:length).eq.'nlon')) then
        nlon_base = dim_info(n)%length
     elseif((dim_info(n)%name(:length).eq.'lev').or.(dim_info(n)%name(:length).eq.'z_t')) then
        nlev_base = dim_info(n)%length
     elseif(dim_info(n)%name(:length).eq.'time') then
        ntim_base = dim_info(n)%length
     endif
  enddo
  !
  if (nlev_base.eq.32) ispcm1  = .true.
  if (nlev_base.eq.40) isccsm3 = .true.
  if (nlev_base.eq.60) isccsm4 = .true.
  !
  ! If history format, step through ocean datasets
  !
  if (ishist) then
     do ifile = 1,nfile
        slc_dataset = 'DSL.'//trim(ocn_history(ifile))
        dim_counter = 0
        var_counter = 0
        call open_cdf(ncid_hist,trim(ocn_history(ifile)),.true.)
        call get_dims(ncid_hist)
        call get_vars(ncid_hist)
        !
        ! Get ocean dataset dimensions
        do n=1,dim_counter
           length = len_trim(dim_info(n)%name)
           if((dim_info(n)%name(:length).eq.'lat').or.(dim_info(n)%name(:length).eq.'nlat')) then
              nlat_hist = dim_info(n)%length
           elseif((dim_info(n)%name(:length).eq.'lon').or.(dim_info(n)%name(:length).eq.'nlon')) then
              nlon_hist = dim_info(n)%length
           elseif((dim_info(n)%name(:length).eq.'lev').or.(dim_info(n)%name(:length).eq.'z_t')) then
              nlev_hist = dim_info(n)%length
           elseif(dim_info(n)%name(:length).eq.'time') then
              ntim_hist = dim_info(n)%length
           endif
        enddo
        !
        ! Get coordinate variables
        !
        if (ispcm1) then
           call read_var(ncid_hist,'lon',ocn_lon)
           call read_var(ncid_hist,'lat',ocn_lat)
        else
           do i=1,nlon_hist
              ocn_lon(i)=i
           end do
           do i=1,nlat_hist
              ocn_lat(i)=i
           end do
        endif

     end do

!===============================================================================
! CVS $Id: shr_const_mod.F90,v 1.2 2003/11/22 00:27:07 tcraig Exp $
! CVS $Source: /fs/cgd/csm/models/CVS.REPOS/shared/csm_share/shr/shr_const_mod.F90,v $
! CVS $Name: ccsm3_0_beta19 $
!===============================================================================

MODULE shr_const_mod

   use shr_kind_mod, only: SHR_KIND_R8

   !----------------------------------------------------------------------------
   ! physical constants (all data public)
   !----------------------------------------------------------------------------
   public
   real(SHR_KIND_R8),parameter :: SHR_CONST_PI     = 3.14159265358979323846_SHR_KIND_R8  ! pi
   real(SHR_KIND_R8),parameter :: SHR_CONST_CDAY   = 86400.0_SHR_KIND_R8      ! sec in calendar day ~ sec
   real(SHR_KIND_R8),parameter :: SHR_CONST_SDAY   = 86164.0_SHR_KIND_R8      ! sec in siderial day ~ sec
   real(SHR_KIND_R8),parameter :: SHR_CONST_OMEGA  = 2.0_SHR_KIND_R8*SHR_CONST_PI/SHR_CONST_SDAY ! earth rot ~ rad/sec
   real(SHR_KIND_R8),parameter :: SHR_CONST_REARTH = 6.37122e6_SHR_KIND_R8    ! radius of earth ~ m
   real(SHR_KIND_R8),parameter :: SHR_CONST_G      = 9.80616_SHR_KIND_R8      ! acceleration of gravity ~ m/s^2
   real(SHR_KIND_R8),parameter :: SHR_CONST_PSTD   = 101325.0_SHR_KIND_R8     ! standard pressure ~ pascals

   real(SHR_KIND_R8),parameter :: SHR_CONST_STEBOL = 5.67e-8_SHR_KIND_R8      ! Stefan-Boltzmann constant ~ W/m^2/K^4
   real(SHR_KIND_R8),parameter :: SHR_CONST_BOLTZ  = 1.38065e-23_SHR_KIND_R8  ! Boltzmann's constant ~ J/K/molecule
   real(SHR_KIND_R8),parameter :: SHR_CONST_AVOGAD = 6.02214e26_SHR_KIND_R8   ! Avogadro's number ~ molecules/kmole
   real(SHR_KIND_R8),parameter :: SHR_CONST_RGAS   = SHR_CONST_AVOGAD*SHR_CONST_BOLTZ ! Universal gas constant ~ J/K/kmole
   real(SHR_KIND_R8),parameter :: SHR_CONST_MWDAIR = 28.966_SHR_KIND_R8       ! molecular weight dry air ~ kg/kmole
   real(SHR_KIND_R8),parameter :: SHR_CONST_MWWV   = 18.016_SHR_KIND_R8       ! molecular weight water vapor
   real(SHR_KIND_R8),parameter :: SHR_CONST_RDAIR  = SHR_CONST_RGAS/SHR_CONST_MWDAIR  ! Dry air gas constant ~ J/K/kg
   real(SHR_KIND_R8),parameter :: SHR_CONST_RWV    = SHR_CONST_RGAS/SHR_CONST_MWWV    ! Water vapor gas constant ~ J/K/kg
   real(SHR_KIND_R8),parameter :: SHR_CONST_ZVIR   = (SHR_CONST_RWV/SHR_CONST_RDAIR)-1.0_SHR_KIND_R8   ! RWV/RDAIR - 1.0
   real(SHR_KIND_R8),parameter :: SHR_CONST_KARMAN = 0.4_SHR_KIND_R8          ! Von Karman constant
 
   real(SHR_KIND_R8),parameter :: SHR_CONST_TKFRZ  = 273.16_SHR_KIND_R8       ! freezing T of fresh water ~ K (intentionally made == to TKTRIP)
   real(SHR_KIND_R8),parameter :: SHR_CONST_TKTRIP = 273.16_SHR_KIND_R8       ! triple point of fresh water ~ K

   real(SHR_KIND_R8),parameter :: SHR_CONST_RHODAIR=SHR_CONST_PSTD/ &
     (SHR_CONST_RDAIR*SHR_CONST_TKFRZ)         ! density of dry air at STP   ~ kg/m^3
   real(SHR_KIND_R8),parameter :: SHR_CONST_RHOFW  = 1.000e3_SHR_KIND_R8      ! density of fresh water ~ kg/m^3
   real(SHR_KIND_R8),parameter :: SHR_CONST_RHOSW  = 1.026e3_SHR_KIND_R8      ! density of sea water ~ kg/m^3
   real(SHR_KIND_R8),parameter :: SHR_CONST_RHOICE = 0.917e3_SHR_KIND_R8      ! density of ice   ~ kg/m^3
   real(SHR_KIND_R8),parameter :: SHR_CONST_CPDAIR = 1.00464e3_SHR_KIND_R8    ! specific heat of dry air ~ J/kg/K
   real(SHR_KIND_R8),parameter :: SHR_CONST_CPFW   = 4.188e3_SHR_KIND_R8      ! specific heat of fresh h2o ~ J/kg/K
   real(SHR_KIND_R8),parameter :: SHR_CONST_CPSW   = 3.996e3_SHR_KIND_R8      ! specific heat of sea h2o ~ J/kg/K
   real(SHR_KIND_R8),parameter :: SHR_CONST_CPWV   = 1.810e3_SHR_KIND_R8      ! specific heat of water vap ~ J/kg/K
   real(SHR_KIND_R8),parameter :: SHR_CONST_CPICE  = 2.11727e3_SHR_KIND_R8    ! specific heat of fresh ice ~ J/kg/K
   real(SHR_KIND_R8),parameter :: SHR_CONST_LATICE = 3.337e5_SHR_KIND_R8      ! latent heat of fusion ~ J/kg
   real(SHR_KIND_R8),parameter :: SHR_CONST_LATVAP = 2.501e6_SHR_KIND_R8      ! latent heat of evaporation ~ J/kg
   real(SHR_KIND_R8),parameter :: SHR_CONST_LATSUB = SHR_CONST_LATICE + SHR_CONST_LATVAP ! latent heat of sublimation ~ J/kg
   real(SHR_KIND_R8),parameter :: SHR_CONST_OCN_REF_SAL = 34.7_SHR_KIND_R8    ! ocn ref salinity (psu)
   real(SHR_KIND_R8),parameter :: SHR_CONST_ICE_REF_SAL =  4.0_SHR_KIND_R8    ! ice ref salinity (psu)

   real(SHR_KIND_R8),parameter :: SHR_CONST_SPVAL       = 1.0e30_SHR_KIND_R8  ! special missing value

END MODULE shr_const_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine check_exists(file)
  !
  ! Check and make sure 'file' exists
  !
  character(len=*),intent(in)::file
  !
  logical::exists
  !
  inquire(file=trim(file),exist=exists)
  if (.not.(exists)) then
     write(*,'(a,'' not found. STOP.'')') trim(file)
     call abort()
  endif
end subroutine check_exists

!
! define module with counters and maximum dimensions
!
module counters_netcdf_jfl
  !
  integer :: dim_counter  = 0
  integer :: var_counter  = 0
  integer :: time_counter = 0
  integer, parameter :: dim_max =  100
  integer, parameter :: var_max = 1000
  !
end module counters_netcdf_jfl
!
! define module with structure definitions
!
module definitions_netcdf_jfl
  !
  use counters_netcdf_jfl
  !
  type DimInfo
     character*32  name
     integer       id,length,ncid
     character*132 file_name
  end type DimInfo
  !
  type VarInfo
     character*32  name,format,type
     integer       id,nvdims,ncid
     integer       vdims(10)
     character*132 file_name
  end type VarInfo
  !
  type(DimInfo), dimension(dim_max) :: dim_info
  type(VarInfo), dimension(var_max) :: var_info
  !
end module definitions_netcdf_jfl
!
! define module with explicit subroutine interface
! and definition of generic subroutines (read_var and
! write_var).
!
module interfaces_netcdf_jfl
  !
  interface
     subroutine def_dim(ncid,dim_name&
          ,dim_length)
       integer, intent(in) :: ncid,dim_length
       character(*), intent(in) :: dim_name
     end subroutine def_dim
  end interface
  !
  interface
     subroutine def_var(ncid,var_name&
          ,format&
          ,type&
          ,units&
          ,long_name)
       integer, intent(in) :: ncid
       character(*), intent(in)           :: var_name
       character(*), intent(in)           :: format
       character(*), intent(in)           :: type
       character(*), intent(in), optional :: units
       character(*), intent(in), optional :: long_name
     end subroutine def_var
  end interface
  !
  interface def_att
     subroutine write_att_text(ncid,var_name,att_name,att_val)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: att_name
       character(*), intent(in) :: att_val
     end subroutine write_att_text
     subroutine write_att_real(ncid,var_name,att_name,att_val)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: att_name
       real        , intent(in) :: att_val
     end subroutine write_att_real
     subroutine write_att_dble(ncid,var_name,att_name,att_val)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: att_name
       real*8      , intent(in) :: att_val
     end subroutine write_att_dble
     subroutine write_att_int(ncid,var_name,att_name,att_val)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: att_name
       integer     , intent(in) :: att_val
     end subroutine write_att_int
  end interface
  !
  interface get_att
     subroutine read_att_text(ncid,var_name,att_name,att_val)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: att_name
       character(*), intent(in) :: att_val
     end subroutine read_att_text
     subroutine read_att_real(ncid,var_name,att_name,att_val)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: att_name
       real        , intent(in) :: att_val
     end subroutine read_att_real
     subroutine read_att_dble(ncid,var_name,att_name,att_val)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: att_name
       real*8      , intent(in) :: att_val
     end subroutine read_att_dble
     subroutine read_att_int(ncid,var_name,att_name,att_val)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: att_name
       integer     , intent(in) :: att_val
     end subroutine read_att_int
  end interface
  !
  interface write_var
     subroutine write_var_c_0(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: array
     end subroutine write_var_c_0
     subroutine write_var_c_1(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: array(:)
     end subroutine write_var_c_1
     subroutine write_var_c_2(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: array(:,:)
     end subroutine write_var_c_2
     subroutine write_var_i_0(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       integer     , intent(in) :: array
     end subroutine write_var_i_0
     subroutine write_var_i_1(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       integer     , intent(in) :: array(:)
     end subroutine write_var_i_1
     subroutine write_var_i_2(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       integer     , intent(in) :: array(:,:)
     end subroutine write_var_i_2
     subroutine write_var_i_3(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       integer     , intent(in) :: array(:,:,:)
     end subroutine write_var_i_3
     subroutine write_var_f_0(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array
     end subroutine write_var_f_0
     subroutine write_var_f_1(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array(:)
     end subroutine write_var_f_1
     subroutine write_var_f_2(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array(:,:)
     end subroutine write_var_f_2
     subroutine write_var_f_3(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array(:,:,:)
     end subroutine write_var_f_3
     subroutine write_var_f_4(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array(:,:,:,:)
     end subroutine write_var_f_4
     subroutine write_var_d_0(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real*8      , intent(in) :: array
     end subroutine write_var_d_0
     subroutine write_var_d_1(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real*8      , intent(in) :: array(:)
     end subroutine write_var_d_1
     subroutine write_var_d_2(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real*8      , intent(in) :: array(:,:)
     end subroutine write_var_d_2
     subroutine write_var_d_3(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real*8      , intent(in) :: array(:,:,:)
     end subroutine write_var_d_3
  end interface
  !
  interface read_var
     subroutine read_var_c_0(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: array
     end subroutine read_var_c_0
     subroutine read_var_c_1(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: array(:)
     end subroutine read_var_c_1
     subroutine read_var_c_2(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       character(*), intent(in) :: array(:,:)
     end subroutine read_var_c_2
     subroutine read_var_i_0(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       integer     , intent(in) :: array
     end subroutine read_var_i_0
     subroutine read_var_i_1(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       integer     , intent(in) :: array(:)
     end subroutine read_var_i_1
     subroutine read_var_i8_1(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       integer*8   , intent(in) :: array(:)
     end subroutine read_var_i8_1
     subroutine read_var_i_2(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       integer     , intent(in) :: array(:,:)
     end subroutine read_var_i_2
     subroutine read_var_i_3(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       integer     , intent(in) :: array(:,:,:)
     end subroutine read_var_i_3
     subroutine read_var_f_0(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array
     end subroutine read_var_f_0
     subroutine read_var_f_1(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array(:)
     end subroutine read_var_f_1
     subroutine read_var_f_2(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array(:,:)
     end subroutine read_var_f_2
     subroutine read_var_f_3(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array(:,:,:)
     end subroutine read_var_f_3
     subroutine read_var_f_4(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       real        , intent(in) :: array(:,:,:,:)
     end subroutine read_var_f_4
     subroutine read_var_d_0(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       double precision, intent(in) :: array
     end subroutine read_var_d_0
     subroutine read_var_d_1(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       double precision, intent(in) :: array(:)
     end subroutine read_var_d_1
     subroutine read_var_d_2(ncid,var_name,array)
       integer     , intent(in) :: ncid
       character(*), intent(in) :: var_name
       double precision, intent(in) :: array(:,:)
     end subroutine read_var_d_2
  end interface
  !
end module interfaces_netcdf_jfl

program calculate_sea_level_change
  !
  ! netCDF I/O subroutines
  !
  use counters_netcdf_jfl
  use interfaces_netcdf_jfl
  use definitions_netcdf_jfl
  use state_ccsm_mod
  use kinds_mod
  !
  !  use netcdf
  !
  implicit none
  include 'netcdf.inc'
  !
  ! Requirements:
  ! base state file;
  ! 1 to N input files;
  ! one auxiliary grid information file.
  ! All in netCDF format.
  !
  ! Argument one is "history" or "singlevar" - REQUIRED
  !
  ! Argument two is the "base" ocn file, ie, the one from which
  !  sea level change is to be computed
  ! If arg0 is "history", then
  !  Arguments 3 to N are the ocean files for which SLC should be computed (up to 1000 files)
  ! If arg0 is "singlevar", then
  !  Argument  3 is the TEMP data
  !  Argument  4 is the SALT data
  !  Argument  5 is the SSH data
  !  Argument  6 is the RHO data
  !
  ! Example history input file:
  ! history
  ! B06.62.ocn.1000-1100Ave.nc
  ! B06.62.ocn.1000.nc
  ! B06.62.ocn.1001.nc
  ! [...]
  ! B06.62.ocn.1099.nc
  ! B06.62.ocn.1100.nc
  !
  ! Example singlevar input file:
  ! singlevar
  ! b40.1850.track1.1deg.006.pop.h.0800-ave-1299.nc
  ! b40.20th.track1.1deg.008.pop.h.RHO.192001-192912.nc
  ! b40.20th.track1.1deg.008.pop.h.SALT.192001-192912.nc
  ! b40.20th.track1.1deg.008.pop.h.SSH.192001-192912.nc
  ! b40.20th.track1.1deg.008.pop.h.TEMP.192001-192912.nc
  !
  ! The auxiliary file for PCM contains POP grid information (pcm1_grid.nc)
  !
  ! Output is a netCDF file containing sea level change
  !
  real ,parameter :: spv = -1.e34
  !
  ! Base ocean state data
  !
  integer::ncid_base,nlon_base,nlat_base,nlev_base,ntim_base,status
  real, dimension(:,:) , allocatable :: base_ssh
  real, dimension(:,:,:) , allocatable :: base_temp,base_salt,base_rho
  !
  ! Ocean data for which to calculate SLC, history file format
  !
  integer :: ncid_hist,nlon_hist,nlat_hist,nlev_hist,ntim_hist
  !
  ! Ocean data for which to calculate SLC, singlevar format
  !
  integer :: ncid_temp,nlon_temp,nlat_temp,nlev_temp,ntim_temp
  integer :: ncid_salt,nlon_salt,nlat_salt,nlev_salt,ntim_salt
  integer :: ncid_ssh,nlon_ssh,nlat_ssh,nlev_ssh,ntim_ssh
  integer :: ncid_rho,nlon_rho,nlat_rho,nlev_rho,ntim_rho
  !
  ! Working arrays
  !
  real, dimension(:)      , allocatable :: ocn_lon,ocn_lat,ocn_lev
  real, dimension(:,:)    , allocatable :: ocn_ssh
  real, dimension(:,:,:)  , allocatable :: ocn_temp,ocn_salt,ocn_rho
  real (r4),dimension(:,:), allocatable :: ocn_tempd,ocn_saltd
  real (r8),dimension(:,:), allocatable :: ocn_dend,ocn_den_t,ocn_den_s
  integer, dimension(:,:), allocatable :: kmt
  logical, dimension(:,:), allocatable :: kmtm
  !
  ! Grid data
  !
  integer :: ncid_grid,nlon_grid,nlat_grid,nlev_grid
  real, dimension(:) , allocatable :: grid_dz,grid_dzw
  real, dimension(:,:) , allocatable :: grid_dxt,grid_dyt
  !
  ! Sea level change data
  !
  integer :: ncid_slc,nlon_slc,nlat_slc,nlev_slc,ntim_slc
  real, dimension(:) , allocatable :: slc_lon,slc_lat,slc_lev
  real, dimension(:,:) , allocatable :: slc,dssh,steric
  real, dimension(:,:) , allocatable :: slc_t,steric_t
  real, dimension(:,:) , allocatable :: slc_s,steric_s
  real :: gave_steric,gave_dssh,gave_slc
  real :: gave_steric_t,gave_slc_t
  real :: gave_steric_s,gave_slc_s
  !
  integer :: i,j,k,l,n,ier,length,io_status,ifile,nfile
  integer :: cnt_hist,cnt_temp,cnt_salt,cnt_ssh,cnt_rho
  integer :: cnt_base,cnt_grid,cnt_slc
  real :: rho_base1,rho_ocn1,rho_ocn_t,rho_ocn_s
  real :: ocn_area,ocn_time,time
  logical :: exists,ishist,issvar,ispcm1,isccsm3,isccsm4
  character(len=132) :: dataset_type
  character(len=132) :: base_ocean_dataset,slc_dataset
  character(len=132) :: temp_dataset,salt_dataset,rho_dataset,ssh_dataset
  character(len=132),dimension(1000) :: ocn_history
  !
  exists = .false.
  ishist = .false.
  issvar = .false.
  ispcm1 = .false.
  isccsm3 = .false.
  isccsm4 = .false.
  !
  read (*,*) dataset_type
  if (dataset_type == "history") then
     write(*,*) 'History file format data.'
     ishist = .true.
  elseif (dataset_type == "singlevar") then
     write(*,*) 'Single variable format data.'
     issvar = .true.
  else
     write(*,*) 'Unknown dataset format. DIE!'
     call abort()
  endif
  !
  read (*,*) base_ocean_dataset
  call check_exists(base_ocean_dataset)
  write(*,'(a,'' is base ocean state.'')') trim(base_ocean_dataset)
  !
  if (ishist) then
     io_status = 0
     ifile = 1
     do while (io_status == 0)
        read(*,*,iostat=io_status) ocn_history(ifile)
        if (io_status == 0) then
           call check_exists(ocn_history(ifile))
           ifile = ifile + 1
        endif
     enddo
     nfile = ifile - 1
  endif
  if (issvar) then
     read(*,*) rho_dataset
     read(*,*) salt_dataset
     read(*,*) ssh_dataset
     read(*,*) temp_dataset
     call check_exists(temp_dataset)
     call check_exists(salt_dataset)
     call check_exists(ssh_dataset)
     call check_exists(rho_dataset)
  endif
  !
  ! Get base ocean data
  !
  call open_cdf(ncid_base,trim(base_ocean_dataset),.true.)
  call get_dims(ncid_base)
  call get_vars(ncid_base)
  !
  ! Get base ocean dimensions
  !
  do n=1,dim_counter
     length = len_trim(dim_info(n)%name)
     if((dim_info(n)%name(:length).eq.'lat').or.(dim_info(n)%name(:length).eq.'nlat')) then
        nlat_base = dim_info(n)%length
     elseif((dim_info(n)%name(:length).eq.'lon').or.(dim_info(n)%name(:length).eq.'nlon')) then
        nlon_base = dim_info(n)%length
     elseif((dim_info(n)%name(:length).eq.'lev').or.(dim_info(n)%name(:length).eq.'z_t')) then
        nlev_base = dim_info(n)%length
     elseif(dim_info(n)%name(:length).eq.'time') then
        ntim_base = dim_info(n)%length
     endif
  enddo
  !
  if (nlev_base.eq.32) ispcm1  = .true.
  if (nlev_base.eq.40) isccsm3 = .true.
  if (nlev_base.eq.60) isccsm4 = .true.
  !
  allocate(base_temp(nlon_base,nlat_base,nlev_base))
  allocate(base_salt(nlon_base,nlat_base,nlev_base))
  allocate(base_rho (nlon_base,nlat_base,nlev_base))
  allocate(base_ssh (nlon_base,nlat_base))
  !
  allocate(ocn_tempd(nlon_base,nlat_base))
  allocate(ocn_saltd(nlon_base,nlat_base))
  allocate(ocn_dend (nlon_base,nlat_base))
  allocate(ocn_den_t(nlon_base,nlat_base))
  allocate(ocn_den_s(nlon_base,nlat_base))
  !
  if (ispcm1) then
     !
     ! Get PCM grid data from PCM grid dataset
     call check_exists('pcm1_grid.nc')
     !
     call open_cdf(ncid_grid,'pcm1_grid.nc',.true.)
     call get_dims(ncid_grid)
     call get_vars(ncid_grid)
     !
     ! Get grid ocean dimensions
     do n=1,dim_counter
        length = len_trim(dim_info(n)%name)
        if(dim_info(n)%name(:length).eq.'jc') then
           nlat_grid = dim_info(n)%length
        elseif(dim_info(n)%name(:length).eq.'ic') then
           nlon_grid = dim_info(n)%length
        elseif(dim_info(n)%name(:length).eq.'zmid') then
           nlev_grid = dim_info(n)%length
        endif
     enddo
     !
     allocate(grid_dxt(nlon_grid,nlat_grid))
     allocate(grid_dyt(nlon_grid,nlat_grid))
     allocate(grid_dz ( nlev_grid))
     !
     ! Get grid DXT, DYT, and DZ
     call read_var(ncid_grid,'dxt',grid_dxt)
     call read_var(ncid_grid,'dyt',grid_dyt)
     call read_var(ncid_grid,'dz' ,grid_dz )
     call close_cdf(ncid_grid)
     write(*,'(''Grid information read from pcm1_grid.nc'')')
  else
     ! CCSM3/CCSM4 data
     allocate(grid_dxt(nlon_base,nlat_base))
     allocate(grid_dyt(nlon_base,nlat_base))
     allocate(kmt     (nlon_base,nlat_base))
     allocate(kmtm    (nlon_base,nlat_base))
     allocate(grid_dz (nlev_base),grid_dzw(nlev_base))
     call read_var(ncid_base,'DXT',grid_dxt)
     call read_var(ncid_base,'DYT',grid_dyt)
     call read_var(ncid_base,'dzw',grid_dzw)
     call read_var(ncid_base,'dz' ,grid_dz)
     call read_var(ncid_base,'KMT',kmt)
     write(*,'(''Grid information read from '',a)') trim(base_ocean_dataset)
  endif
  !
  ! Get base ocean data T, S, and SSH
  cnt_base = 0
  do n=1,ntim_base
     time_counter = n
     cnt_base = cnt_base + 1
     if (ispcm1) then
        call read_var(ncid_base,'temp',base_temp)
        call read_var(ncid_base,'s' ,base_salt)
        call read_var(ncid_base,'ah1' ,base_ssh)
     else
        call read_var(ncid_base,'TEMP',base_temp)
        call read_var(ncid_base,'SALT',base_salt)
        call read_var(ncid_base,'SSH' ,base_ssh)
        if (isccsm4) call read_var(ncid_base,'RHO',base_rho)
     endif
  enddo
  call close_cdf(ncid_base)
  write(*,*) 'BASE S,T: ',(base_temp(230,150,k),base_salt(230,150,k),k=1,nlev_base)
  write(*,'(a,'' base state data read.'')') trim(base_ocean_dataset)
  !
  ! Where base T/S/SSH fields are land, set to zero, correct SALT from ppt to parts
  !
  where (base_ssh  > 1.e10)
     base_ssh  = 0
  end where
  where (base_temp > 1.e10)
     base_temp = 0
  end where
  where (base_salt > 1.e10)
     base_salt = 0
  end where
  where (base_salt > 1.)
     base_salt = base_salt*1.e-3
  end where
  if (isccsm4) then
     where (base_rho > 1.e10)
        base_rho = 0
     end where
  endif
  !
  if ((isccsm3).or.(isccsm4)) then
     do k=2,nlev_base
        grid_dzw(k)=grid_dzw(k-1)+grid_dzw(k)
     end do
     call init_state('mwjf',grid_dzw)
  endif
  if (isccsm3) then
     print*,'grid_dzw=',(grid_dzw(k),k=1,40)
     print*,'grid_dz=',(grid_dz(k),k=1,40)
     do k = 1,nlev_base
        kmtm = .False.
        where (kmt >= k)
           kmtm = .true.
        end where
        ocn_tempd=base_temp(:,:,k)
        ocn_saltd=base_salt(:,:,k)   ! *0.001
        call state_ccsm(k,k,ocn_tempd,ocn_saltd,ocn_dend,kmtm,spv)
        where (kmt < k)
           ocn_dend = 100
        end where
        base_rho(:,:,k)=ocn_dend
     end do
  endif
  if (isccsm4) then
     do k = 1,nlev_base
        kmtm = .False.
        where (kmt >= k)
           kmtm = .true.
        end where
        where (kmt < k)
           base_rho(:,:,k) = 100
        end where
     end do
  endif
  !
  ! If history format, step through ocean datasets
  !
  if (ishist) then
     do ifile = 1,nfile
        slc_dataset = 'DSL.'//trim(ocn_history(ifile))
        dim_counter = 0
        var_counter = 0
        call open_cdf(ncid_hist,trim(ocn_history(ifile)),.true.)
        call get_dims(ncid_hist)
        call get_vars(ncid_hist)
        !
        ! Get ocean dataset dimensions
        do n=1,dim_counter
           length = len_trim(dim_info(n)%name)
           if((dim_info(n)%name(:length).eq.'lat').or.(dim_info(n)%name(:length).eq.'nlat')) then
              nlat_hist = dim_info(n)%length
           elseif((dim_info(n)%name(:length).eq.'lon').or.(dim_info(n)%name(:length).eq.'nlon')) then
              nlon_hist = dim_info(n)%length
           elseif((dim_info(n)%name(:length).eq.'lev').or.(dim_info(n)%name(:length).eq.'z_t')) then
              nlev_hist = dim_info(n)%length
           elseif(dim_info(n)%name(:length).eq.'time') then
              ntim_hist = dim_info(n)%length
           endif
        enddo
        !
        allocate(ocn_temp(nlon_hist,nlat_hist,nlev_hist))
        allocate(ocn_salt(nlon_hist,nlat_hist,nlev_hist))
        allocate(ocn_rho (nlon_hist,nlat_hist,nlev_hist))
        allocate(ocn_ssh (nlon_hist,nlat_hist          ))
        allocate(slc     (nlon_hist,nlat_hist          ))
        allocate(slc_t   (nlon_hist,nlat_hist          ))
        allocate(slc_s   (nlon_hist,nlat_hist          ))
        allocate(steric  (nlon_hist,nlat_hist          ))
        allocate(steric_t(nlon_hist,nlat_hist          ))
        allocate(steric_s(nlon_hist,nlat_hist          ))
        allocate(dssh    (nlon_hist,nlat_hist          ))
        allocate(ocn_lon (nlon_hist                    ))
        allocate(ocn_lat (nlat_hist                    ))
        !
        ! Get coordinate variables
        !
        if (ispcm1) then
           call read_var(ncid_hist,'lon',ocn_lon)
           call read_var(ncid_hist,'lat',ocn_lat)
        else
           do i=1,nlon_hist
              ocn_lon(i)=i
           end do
           do i=1,nlat_hist
              ocn_lat(i)=i
           end do
        endif
        !
        ! Define SLC dataset
        !
        call create_cdf(ncid_slc,trim(slc_dataset))
        !
        call def_dim(ncid_slc,'lon',nlon_hist)
        call def_dim(ncid_slc,'lat',nlat_hist)
        call def_dim(ncid_slc,'time',0)
        !
        call def_var(ncid_slc,'lon' ,'lon' ,'float',' ','longitude')
        call def_var(ncid_slc,'lat' ,'lat' ,'float',' ','latitude')
        call def_var(ncid_slc,'time','time','float','days since 0000-01-01','time')
        call def_att(ncid_slc,'time','calendar','noleap')
        !
        call def_var(ncid_slc,'slc' ,'lon,lat,time','float','cm','total sea level change')
        call def_att(ncid_slc,'slc','missing_value',spv)
        call def_att(ncid_slc,'slc','_FillValue',spv)
        call def_var(ncid_slc,'slc_t' ,'lon,lat,time','float','cm','total sea level change thermal only')
        call def_att(ncid_slc,'slc_t','missing_value',spv)
        call def_att(ncid_slc,'slc_t','_FillValue',spv)
        call def_var(ncid_slc,'slc_s' ,'lon,lat,time','float','cm','total sea level change salinity only')
        call def_att(ncid_slc,'slc_s','missing_value',spv)
        call def_att(ncid_slc,'slc_s','_FillValue',spv)
        call def_var(ncid_slc,'delta_ssh','lon,lat,time','float','cm','sea surface ht change' )
        call def_att(ncid_slc,'delta_ssh','missing_value',spv)
        call def_att(ncid_slc,'delta_ssh','_FillValue',spv)
        call def_var(ncid_slc,'delta_steric','lon,lat,time','float','cm','steric change' )
        call def_att(ncid_slc,'delta_steric','missing_value',spv)
        call def_att(ncid_slc,'delta_steric','_FillValue',spv)
        call def_var(ncid_slc,'delta_steric_t','lon,lat,time','float','cm','steric change thermal only' )
        call def_att(ncid_slc,'delta_steric_t','missing_value',spv)
        call def_att(ncid_slc,'delta_steric_t','_FillValue',spv)
        call def_var(ncid_slc,'delta_steric_s','lon,lat,time','float','cm','steric change salinity only' )
        call def_att(ncid_slc,'delta_steric_s','missing_value',spv)
        call def_att(ncid_slc,'delta_steric_s','_FillValue',spv)
        !
        call def_var(ncid_slc,'ave_slc','time','float','cm','global ave total SLC')
        call def_att(ncid_slc,'ave_slc','missing_value',spv)
        call def_att(ncid_slc,'ave_slc','_FillValue',spv)
        call def_var(ncid_slc,'ave_slc_t','time','float','cm','global ave total SLC thermal only')
        call def_att(ncid_slc,'ave_slc_t','missing_value',spv)
        call def_att(ncid_slc,'ave_slc_t','_FillValue',spv)
        call def_var(ncid_slc,'ave_slc_s','time','float','cm','global ave total SLC salinity only')
        call def_att(ncid_slc,'ave_slc_s','missing_value',spv)
        call def_att(ncid_slc,'ave_slc_s','_FillValue',spv)
        call def_var(ncid_slc,'ave_delta_ssh','time','float','cm','global ave SSH change' )
        call def_att(ncid_slc,'ave_delta_ssh','missing_value',spv)
        call def_att(ncid_slc,'ave_delta_ssh','_FillValue',spv)
        call def_var(ncid_slc,'ave_delta_steric','time','float','cm','global ave steric change')
        call def_att(ncid_slc,'ave_delta_steric','missing_value',spv)
        call def_att(ncid_slc,'ave_delta_steric','_FillValue',spv)
        call def_var(ncid_slc,'ave_delta_steric_t','time','float','cm','global ave steric change thermal only')
        call def_att(ncid_slc,'ave_delta_steric_t','missing_value',spv)
        call def_att(ncid_slc,'ave_delta_steric_t','_FillValue',spv)
        call def_var(ncid_slc,'ave_delta_steric_s','time','float','cm','global ave steric change salinity only')
        call def_att(ncid_slc,'ave_delta_steric_s','missing_value',spv)
        call def_att(ncid_slc,'ave_delta_steric_s','_FillValue',spv)
        !
        call end_def(ncid_slc)
        !
        call write_var(ncid_slc,'lon',ocn_lon)
        call write_var(ncid_slc,'lat',ocn_lat)
        !
        ! Begin calculation
        !
        do n = 1,ntim_hist
           time_counter = n
           if (ispcm1) then
              call read_var(ncid_hist,'s'   ,ocn_salt)
              call read_var(ncid_hist,'ah1' ,ocn_ssh)
              call read_var(ncid_hist,'temp',ocn_temp)
           else
              call read_var(ncid_hist,'RHO' ,ocn_rho)
              call read_var(ncid_hist,'SSH' ,ocn_ssh)
              call read_var(ncid_hist,'SALT',ocn_salt)
              call read_var(ncid_hist,'TEMP',ocn_temp)
           endif
           call read_var(ncid_hist,'time',ocn_time)
           call write_var(ncid_slc,'time',ocn_time)
           write(*,'(a,''     data at time '',i3,'' ('',f12.3,'') read.'')') &
                trim(ocn_history(ifile)),n,ocn_time
           !
           ! Where T/S/SSH fields are land, set to zero
           !
           where (ocn_ssh  > 1.e10)
              ocn_ssh  = 0
           end where
           if (ispcm1) then
              where (ocn_temp > 1.e10)
                 ocn_temp =   0.
              end where
              where (ocn_salt > 1.e10)
                 ocn_salt =   0.
              end where
           else
              where (ocn_rho  > 1.e10)
                 ocn_rho  = 100.
              end where
              where (ocn_temp > 1.e10)
                 ocn_temp =   0.
              end where
              where (ocn_salt > 1.e10)
                 ocn_salt =   0.
              end where
              where (ocn_salt > 1.)
                 ocn_salt = ocn_salt*1.e-3
              end where
           endif
           print*,ocn_temp(30,100,1),ocn_salt(30,100,1),ocn_rho(30,100,1)
           print*,base_temp(30,100,1),base_salt(30,100,1),base_rho(30,100,1)
           !
           ! Do the state calculations
           !
           steric   = 0.
           steric_t = 0.
           steric_s = 0.
           do k = 1,nlev_hist
              if ((isccsm3).or.(isccsm4)) then
                 kmtm = .False.
                 where (kmt >= k)
                    kmtm = .true.
                 end where
                 ! thermal effect only on SLC
                 ocn_tempd=ocn_temp(:,:,k)
                 ocn_saltd=base_salt(:,:,k) !*0.001
                 call state_ccsm(k,k,ocn_tempd,ocn_saltd,ocn_dend,kmtm,spv)
                 where (kmt < k)
                    ocn_dend = 100
                 end where
                 ocn_den_t=ocn_dend
                 ! salt effect only on SLC
                 ocn_tempd=base_temp(:,:,k)
                 ocn_saltd=ocn_salt(:,:,k)
                 call state_ccsm(k,k,ocn_tempd,ocn_saltd,ocn_dend,kmtm,spv)
                 where (kmt < k)
                    ocn_dend = 100
                 end where
                 ocn_den_s=ocn_dend
                 ocn_tempd=ocn_temp(:,:,k)
                 ocn_saltd=ocn_salt(:,:,k)
                 call state_ccsm(k,k,ocn_tempd,ocn_saltd,ocn_dend,kmtm,spv)
                 where (kmt < k)
                    ocn_dend = 100
                 end where
              endif
              if (ispcm1) then
                 do j = 1,nlat_hist
                    do i = 1,nlon_hist
                       call state_pcm(k,base_temp(i,j,k),base_salt(i,j,k),rho_base1)
                       call state_pcm(k, ocn_temp(i,j,k), ocn_salt(i,j,k),rho_ocn1)
                       call state_pcm(k, ocn_temp(i,j,k),base_salt(i,j,k),rho_ocn_t)
                       call state_pcm(k,base_temp(i,j,k), ocn_salt(i,j,k),rho_ocn_s)
                       if (i.eq.230.and.j.eq.150) then
                          print*,'rho_base= ',rho_base1,' rho_hist=',rho_ocn1
                       endif
                       steric(i,j)   = steric(i,j)   + (((rho_base1/rho_ocn1 )-1.)*grid_dz(k))
                       steric_t(i,j) = steric_t(i,j) + (((rho_base1/rho_ocn_t)-1.)*grid_dz(k))
                       steric_s(i,j) = steric_s(i,j) + (((rho_base1/rho_ocn_s)-1.)*grid_dz(k))
                    enddo
                 enddo
              else
                 do j = 1,nlat_hist
                    do i = 1,nlon_hist
                       rho_base1=base_rho(i,j,k)
                       rho_ocn1=ocn_dend(i,j) !rho_ocn(i,j,k)
                       rho_ocn_t=ocn_den_t(i,j)
                       rho_ocn_s=ocn_den_s(i,j)
                       if (i.eq.230.and.j.eq.150) then
                          print*,'rho_base= ',rho_base1,' rho_hist=',rho_ocn1
                       endif
                       steric(i,j)   = steric(i,j)   + (((rho_base1/rho_ocn1 )-1.)*grid_dz(k))
                       steric_t(i,j) = steric_t(i,j) + (((rho_base1/rho_ocn_t)-1.)*grid_dz(k))
                       steric_s(i,j) = steric_s(i,j) + (((rho_base1/rho_ocn_s)-1.)*grid_dz(k))
                    enddo
                 enddo
              endif
           enddo
           write(*,'(a,'' data at time '',i3,'' ('',f12.3,'') SLC calculated.'')') trim(slc_dataset),n,ocn_time
           !
           ! Calculate sea level change, areally averaged
           !
           dssh = ocn_ssh - base_ssh
           !           slc = steric + dssh
           !           slc_t = steric_t + dssh
           !           slc_s = steric_s + dssh
           where (base_ssh == 0.)
              dssh   = spv
              !              slc    = spv ; slc_t    = spv ; slc_s    = spv
              steric = spv
              steric_t = spv
              steric_s = spv
           endwhere
           !
           ocn_area = sum(grid_dxt*grid_dyt,mask=steric/=spv)
           !
           gave_steric   = sum(steric*grid_dxt*grid_dyt,mask=steric/=spv)
           gave_steric_t = sum(steric_t*grid_dxt*grid_dyt,mask=steric/=spv)
           gave_steric_s = sum(steric_s*grid_dxt*grid_dyt,mask=steric/=spv)
           gave_dssh     = sum(dssh*grid_dxt*grid_dyt,mask=dssh/=spv)
           !
           gave_steric   = gave_steric / ocn_area
           gave_steric_t = gave_steric_t / ocn_area
           gave_steric_s = gave_steric_s / ocn_area
           gave_dssh     = gave_dssh / ocn_area
           gave_slc      = gave_steric + gave_dssh
           gave_slc_t    = gave_steric_t + gave_dssh
           gave_slc_s    = gave_steric_s + gave_dssh

           slc           = gave_steric  + dssh
           slc_t         = gave_steric_t + dssh
           slc_s         = gave_steric_s + dssh
           where (base_ssh == 0.)
              slc = spv
              slc_t = spv
              slc_s = spv
           endwhere
           print*,'ocn_area = ',ocn_area ,'gave_steric=',gave_steric
           print*,'gave_dssh=',gave_dssh,'gave_slc=',gave_slc
           !
           call write_var(ncid_slc,'slc'         ,slc)
           call write_var(ncid_slc,'slc_t'       ,slc_t)
           call write_var(ncid_slc,'slc_s'       ,slc_s)
           call write_var(ncid_slc,'delta_ssh'   ,dssh)
           call write_var(ncid_slc,'delta_steric',steric)
           call write_var(ncid_slc,'delta_steric_t',steric_t)
           call write_var(ncid_slc,'delta_steric_s',steric_s)
           !
           call write_var(ncid_slc,'ave_slc'         ,gave_slc)
           call write_var(ncid_slc,'ave_slc_t'       ,gave_slc_t)
           call write_var(ncid_slc,'ave_slc_s'       ,gave_slc_s)
           call write_var(ncid_slc,'ave_delta_ssh'   ,gave_dssh)
           call write_var(ncid_slc,'ave_delta_steric',gave_steric)
           call write_var(ncid_slc,'ave_delta_steric_t',gave_steric_t)
           call write_var(ncid_slc,'ave_delta_steric_s',gave_steric_s)
           !        call write_var(ncid_slc,'rho_base',base_rho(1,:,:))
           !
        enddo
        call close_cdf(ncid_slc)
        deallocate(ocn_temp)
        deallocate(ocn_salt)
        deallocate(ocn_ssh )
        deallocate(slc     )
        deallocate(steric  )
        deallocate(dssh    )
        deallocate(ocn_lon )
        deallocate(ocn_lat )
     enddo
  endif
  !
  ! If singlevar format, step through time
  !
  if (issvar) then
     slc_dataset = 'DSL.'//trim(temp_dataset)
     dim_counter = 0
     var_counter = 0
     !
     ! Get information from each of TEMP, SALT, SSH, and RHO datasets
     call open_cdf(ncid_temp,trim(temp_dataset),.true.)
     call get_dims(ncid_temp)
     call get_vars(ncid_temp)
     do n=1,dim_counter
        length = len_trim(dim_info(n)%name)
        if((dim_info(n)%name(:length).eq.'lat').or.(dim_info(n)%name(:length).eq.'nlat')) then
           nlat_temp = dim_info(n)%length
        elseif((dim_info(n)%name(:length).eq.'lon').or.(dim_info(n)%name(:length).eq.'nlon')) then
           nlon_temp = dim_info(n)%length
        elseif((dim_info(n)%name(:length).eq.'lev').or.(dim_info(n)%name(:length).eq.'z_t')) then
           nlev_temp = dim_info(n)%length
        elseif(dim_info(n)%name(:length).eq.'time') then
           ntim_temp = dim_info(n)%length
        endif
     enddo
     !
     call open_cdf(ncid_salt,trim(salt_dataset),.true.)
     call get_dims(ncid_salt)
     call get_vars(ncid_salt)
     do n=1,dim_counter
        length = len_trim(dim_info(n)%name)
        if((dim_info(n)%name(:length).eq.'lat').or.(dim_info(n)%name(:length).eq.'nlat')) then
           nlat_salt = dim_info(n)%length
        elseif((dim_info(n)%name(:length).eq.'lon').or.(dim_info(n)%name(:length).eq.'nlon')) then
           nlon_salt = dim_info(n)%length
        elseif((dim_info(n)%name(:length).eq.'lev').or.(dim_info(n)%name(:length).eq.'z_t')) then
           nlev_salt = dim_info(n)%length
        elseif(dim_info(n)%name(:length).eq.'time') then
           ntim_salt = dim_info(n)%length
        endif
     enddo
     !
     call open_cdf(ncid_rho,trim(rho_dataset),.true.)
     call get_dims(ncid_rho)
     call get_vars(ncid_rho)
     do n=1,dim_counter
        length = len_trim(dim_info(n)%name)
        if((dim_info(n)%name(:length).eq.'lat').or.(dim_info(n)%name(:length).eq.'nlat')) then
           nlat_rho = dim_info(n)%length
        elseif((dim_info(n)%name(:length).eq.'lon').or.(dim_info(n)%name(:length).eq.'nlon')) then
           nlon_rho = dim_info(n)%length
        elseif((dim_info(n)%name(:length).eq.'lev').or.(dim_info(n)%name(:length).eq.'z_t')) then
           nlev_rho = dim_info(n)%length
        elseif(dim_info(n)%name(:length).eq.'time') then
           ntim_rho = dim_info(n)%length
        endif
     enddo
     !
     call open_cdf(ncid_ssh,trim(ssh_dataset),.true.)
     call get_dims(ncid_ssh)
     call get_vars(ncid_ssh)
     do n=1,dim_counter
        length = len_trim(dim_info(n)%name)
        if((dim_info(n)%name(:length).eq.'lat').or.(dim_info(n)%name(:length).eq.'nlat')) then
           nlat_ssh = dim_info(n)%length
        elseif((dim_info(n)%name(:length).eq.'lon').or.(dim_info(n)%name(:length).eq.'nlon')) then
           nlon_ssh = dim_info(n)%length
        elseif((dim_info(n)%name(:length).eq.'lev').or.(dim_info(n)%name(:length).eq.'z_t')) then
           nlev_ssh = dim_info(n)%length
        elseif(dim_info(n)%name(:length).eq.'time') then
           ntim_ssh = dim_info(n)%length
        endif
     enddo
     !
     ! Assume all dimensions are the same (except for SSH time); put in code here to verify
     !
     allocate(ocn_temp(nlon_temp,nlat_temp,nlev_temp))
     allocate(ocn_salt(nlon_salt,nlat_salt,nlev_salt))
     allocate(ocn_rho (nlon_rho ,nlat_rho ,nlev_rho ))
     allocate(ocn_ssh (nlon_ssh ,nlat_ssh           ))
     !
     allocate(slc     (nlon_temp,nlat_temp         ))
     allocate(slc_t    (nlon_temp,nlat_temp         ))
     allocate(slc_s    (nlon_temp,nlat_temp         ))
     allocate(steric  (nlon_temp,nlat_temp         ))
     allocate(steric_t (nlon_temp,nlat_temp         ))
     allocate(steric_s (nlon_temp,nlat_temp         ))
     allocate(dssh    (nlon_temp,nlat_temp         ))
     allocate(ocn_lon (nlon_temp                  ))
     allocate(ocn_lat (nlat_temp                  ))
     !
     ! Get coordinate variables
     !
     if (ispcm1) then
        call read_var(ncid_temp,'lon',ocn_lon)
        call read_var(ncid_temp,'lat',ocn_lat)
     else
        do i=1,nlon_temp
           ocn_lon(i)=i
        end do
        do i=1,nlat_temp
           ocn_lat(i)=i
        end do
     endif
     !
     ! Define SLC dataset
     !
     call create_cdf(ncid_slc,trim(slc_dataset))
     !
     call def_dim(ncid_slc,'lon',nlon_temp)
     call def_dim(ncid_slc,'lat',nlat_temp)
     call def_dim(ncid_slc,'time',0)
     !
     call def_var(ncid_slc,'lon' ,'lon' ,'float',' ','longitude')
     call def_var(ncid_slc,'lat' ,'lat' ,'float',' ','latitude')
     call def_var(ncid_slc,'time','time','float','days since 0000-01-01','time')
     call def_att(ncid_slc,'time','calendar','noleap')
     !
     call def_var(ncid_slc,'slc' ,'lon,lat,time','float','cm','total sea level change')
     call def_att(ncid_slc,'slc','missing_value',spv)
     call def_att(ncid_slc,'slc','_FillValue',spv)
     call def_var(ncid_slc,'slc_t' ,'lon,lat,time','float','cm','total sea level change thermal only')
     call def_att(ncid_slc,'slc_t','missing_value',spv)
     call def_att(ncid_slc,'slc_t','_FillValue',spv)
     call def_var(ncid_slc,'slc_s' ,'lon,lat,time','float','cm','total sea level change salinity only')
     call def_att(ncid_slc,'slc_s','missing_value',spv)
     call def_att(ncid_slc,'slc_s','_FillValue',spv)
     call def_var(ncid_slc,'delta_ssh','lon,lat,time','float','cm','sea surface ht change' )
     call def_att(ncid_slc,'delta_ssh','missing_value',spv)
     call def_att(ncid_slc,'delta_ssh','_FillValue',spv)
     call def_var(ncid_slc,'delta_steric','lon,lat,time','float','cm','steric change' )
     call def_att(ncid_slc,'delta_steric','missing_value',spv)
     call def_att(ncid_slc,'delta_steric','_FillValue',spv)
     call def_var(ncid_slc,'delta_steric_t','lon,lat,time','float','cm','steric change thermal only' )
     call def_att(ncid_slc,'delta_steric_t','missing_value',spv)
     call def_att(ncid_slc,'delta_steric_t','_FillValue',spv)
     call def_var(ncid_slc,'delta_steric_s','lon,lat,time','float','cm','steric change salinity only' )
     call def_att(ncid_slc,'delta_steric_s','missing_value',spv)
     call def_att(ncid_slc,'delta_steric_s','_FillValue',spv)
     !
     call def_var(ncid_slc,'ave_slc','time','float','cm','global ave total SLC')
     call def_att(ncid_slc,'ave_slc','missing_value',spv)
     call def_att(ncid_slc,'ave_slc','_FillValue',spv)
     call def_var(ncid_slc,'ave_slc_t','time','float','cm','global ave total SLC thermal only')
     call def_att(ncid_slc,'ave_slc_t','missing_value',spv)
     call def_att(ncid_slc,'ave_slc_t','_FillValue',spv)
     call def_var(ncid_slc,'ave_slc_s','time','float','cm','global ave total SLC salinity only')
     call def_att(ncid_slc,'ave_slc_s','missing_value',spv)
     call def_att(ncid_slc,'ave_slc_s','_FillValue',spv)
     call def_var(ncid_slc,'ave_delta_ssh','time','float','cm','global ave SSH change' )
     call def_att(ncid_slc,'ave_delta_ssh','missing_value',spv)
     call def_att(ncid_slc,'ave_delta_ssh','_FillValue',spv)
     call def_var(ncid_slc,'ave_delta_steric','time','float','cm','global ave steric change')
     call def_att(ncid_slc,'ave_delta_steric','missing_value',spv)
     call def_att(ncid_slc,'ave_delta_steric','_FillValue',spv)
     call def_var(ncid_slc,'ave_delta_steric_t','time','float','cm','global ave steric change thermal only')
     call def_att(ncid_slc,'ave_delta_steric_t','missing_value',spv)
     call def_att(ncid_slc,'ave_delta_steric_t','_FillValue',spv)
     call def_var(ncid_slc,'ave_delta_steric_s','time','float','cm','global ave steric change salinity only')
     call def_att(ncid_slc,'ave_delta_steric_s','missing_value',spv)
     call def_att(ncid_slc,'ave_delta_steric_s','_FillValue',spv)
     !
     call end_def(ncid_slc)
     !
     call write_var(ncid_slc,'lon',ocn_lon)
     call write_var(ncid_slc,'lat',ocn_lat)
     !
     ! Begin calculation
     !
     do n = 1,ntim_temp
        time_counter = n
        if (ispcm1) then
           call read_var(ncid_salt,'s'   ,ocn_salt)
           call read_var(ncid_ssh ,'ah1' ,ocn_ssh)
           call read_var(ncid_temp,'temp',ocn_temp)
        else
           call read_var(ncid_rho ,'RHO' ,ocn_rho)
           call read_var(ncid_ssh ,'SSH' ,ocn_ssh)
           call read_var(ncid_salt,'SALT',ocn_salt)
           call read_var(ncid_temp,'TEMP',ocn_temp)
        endif
        call read_var(ncid_temp,'time',ocn_time)
        call write_var(ncid_slc,'time' ,ocn_time)
        write(*,'(a,''     data at time '',i3,'' ('',f12.3,'') read.'')') &
             trim(temp_dataset),n,ocn_time
        !
        ! Where T/S/SSH fields are land, set to zero
        !
        where (ocn_ssh  > 1.e10)
           ocn_ssh  = 0
        end where
        if (ispcm1) then
           where (ocn_temp > 1.e10)
              ocn_temp = 0
           end where
           where (ocn_salt > 1.e10)
              ocn_salt = 0
           end where
        else
           where (ocn_rho > 1.e10)
              ocn_rho = 100
           end where
           where (ocn_temp > 1.e10)
              ocn_temp = 0
           end where
           where (ocn_salt > 1.e10)
              ocn_salt = 0
           end where
           where (ocn_salt > 1.)
              ocn_salt = ocn_salt*1.e-3
           end where
        endif
        !
        ! Do the state calculations
        !
        steric = 0.
        steric_t = 0.
        steric_s = 0.
        do k = 1,nlev_temp
           if ((isccsm3).or.(isccsm4)) then
              kmtm = .False.
              where (kmt >= k)
                 kmtm = .true.
              end where
              ! thermal effect only on SLC
              ocn_tempd=ocn_temp(:,:,k)
              ocn_saltd=base_salt(:,:,k)!*0.001
              call state_ccsm(k,k,ocn_tempd,ocn_saltd,ocn_dend,kmtm,spv)
              where (kmt < k)
                 ocn_dend = 100
              end where
              ocn_den_t=ocn_dend
              ! salt effect only on SLC
              ocn_tempd=base_temp(:,:,k)
              ocn_saltd=ocn_salt(:,:,k)
              call state_ccsm(k,k,ocn_tempd,ocn_saltd,ocn_dend,kmtm,spv)
              where (kmt < k)
                 ocn_dend = 100
              end where
              ocn_den_s=ocn_dend
              ocn_tempd=ocn_temp(:,:,k)
              ocn_saltd=ocn_salt(:,:,k)
              call state_ccsm(k,k,ocn_tempd,ocn_saltd,ocn_dend,kmtm,spv)
              where (kmt < k)
                 ocn_dend = 100
              end where
           endif
           if (ispcm1) then
              do j = 1,nlat_temp
                 do i = 1,nlon_temp
                    call state_pcm(k,base_temp(i,j,k),base_salt(i,j,k),rho_base1)
                    call state_pcm(k, ocn_temp(i,j,k), ocn_salt(i,j,k), rho_ocn1)
                    call state_pcm(k, ocn_temp(i,j,k),base_salt(i,j,k), rho_ocn_t)
                    call state_pcm(k,base_temp(i,j,k), ocn_salt(i,j,k), rho_ocn_s)
                    steric(i,j) = steric(i,j) + (((rho_base1/rho_ocn1)-1.)*grid_dz(k))
                    steric_t(i,j) = steric_t(i,j) + (((rho_base1/rho_ocn_t)-1.)*grid_dz(k))
                    steric_s(i,j) = steric_s(i,j) + (((rho_base1/rho_ocn_s)-1.)*grid_dz(k))
                 enddo
              enddo
           else
              do j = 1,nlat_temp
                 do i = 1,nlon_temp
                    rho_base1=base_rho(i,j,k)
                    rho_ocn1=ocn_dend(i,j) !rho_ocn(i,j,k)
                    !            rho_ocn1=rho_ocn(i,j,k)
                    rho_ocn_t=ocn_den_t(i,j)
                    rho_ocn_s=ocn_den_s(i,j)
                    steric(i,j)   = steric(i,j)   - ((( rho_ocn1/rho_base1)-1.)*grid_dz(k))
                    steric_t(i,j) = steric_t(i,j) - (((rho_ocn_t/rho_base1)-1.)*grid_dz(k))
                    steric_s(i,j) = steric_s(i,j) - (((rho_ocn_s/rho_base1)-1.)*grid_dz(k))
                    ! Old AHU calc
                    ! steric(i,j)   = steric(i,j)   + (((rho_base1/rho_ocn1 )-1.)*grid_dz(k))
                    ! steric_t(i,j) = steric_t(i,j) + (((rho_base1/rho_ocn_t)-1.)*grid_dz(k))
                    ! steric_s(i,j) = steric_s(i,j) + (((rho_base1/rho_ocn_s)-1.)*grid_dz(k))
                 enddo
              enddo
           endif
        enddo
        write(*,'(a,'' data at time '',i3,'' ('',f12.3,'') SLC calculated.'')') trim(slc_dataset),n,ocn_time
        !
        ! Calculate sea level change, areally averaged
        !
        dssh = ocn_ssh - base_ssh
        !        slc = steric + dssh
        !        slc_t = steric_t + dssh
        !        slc_s = steric_s + dssh
        where (base_ssh == 0.)
           dssh   = spv
           !              slc    = spv ; slc_t    = spv ; slc_s    = spv
           steric = spv
           steric_t = spv
           steric_s = spv
        endwhere
        !
        ocn_area = sum(grid_dxt*grid_dyt,mask=steric/=spv)
        !
        gave_steric   = sum(steric*grid_dxt*grid_dyt,mask=steric/=spv)
        gave_steric_t = sum(steric_t*grid_dxt*grid_dyt,mask=steric/=spv)
        gave_steric_s = sum(steric_s*grid_dxt*grid_dyt,mask=steric/=spv)
        gave_dssh     = sum(dssh*grid_dxt*grid_dyt,mask=dssh/=spv)
        !
        gave_steric   = gave_steric / ocn_area
        gave_steric_t = gave_steric_t / ocn_area
        gave_steric_s = gave_steric_s / ocn_area
        gave_dssh     = gave_dssh / ocn_area
        gave_slc      = gave_steric + gave_dssh
        gave_slc_t    = gave_steric_t + gave_dssh
        gave_slc_s    = gave_steric_s + gave_dssh

        slc           = gave_steric  + dssh
        slc_t         = gave_steric_t + dssh
        slc_s         = gave_steric_s + dssh
        print*,'ocn_area = ',ocn_area ,'gave_steric=',gave_steric
        print*,'gave_dssh=',gave_dssh,'gave_slc=',gave_slc
        !
        call write_var(ncid_slc,'slc'         ,slc)
        call write_var(ncid_slc,'slc_t'       ,slc_t)
        call write_var(ncid_slc,'slc_s'       ,slc_s)
        call write_var(ncid_slc,'delta_ssh'   ,dssh)
        call write_var(ncid_slc,'delta_steric',steric)
        call write_var(ncid_slc,'delta_steric_t',steric_t)
        call write_var(ncid_slc,'delta_steric_s',steric_s)
        !
        call write_var(ncid_slc,'ave_slc'         ,gave_slc)
        call write_var(ncid_slc,'ave_slc_t'       ,gave_slc_t)
        call write_var(ncid_slc,'ave_slc_s'       ,gave_slc_s)
        call write_var(ncid_slc,'ave_delta_ssh'   ,gave_dssh)
        call write_var(ncid_slc,'ave_delta_steric',gave_steric)
        call write_var(ncid_slc,'ave_delta_steric_t',gave_steric_t)
        call write_var(ncid_slc,'ave_delta_steric_s',gave_steric_s)
        !        call write_var(ncid_slc,'rho_base',base_rho(1,:,:))
        !
     enddo
     call close_cdf(ncid_slc)
     deallocate(ocn_temp)
     deallocate(ocn_salt)
     deallocate(ocn_ssh )
     deallocate(slc     )
     deallocate(steric  )
     deallocate(dssh    )
     deallocate(ocn_lon )
     deallocate(ocn_lat )
  endif
end program calculate_sea_level_change

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

	 module state_ccsm_mod

!BOP
! !MODULE: state_mod
!
! !DESCRIPTION:
!  This module contains routines necessary for computing the density 
!  from model temperature and salinity using an equation of state.
!
!  The module supports four forms of EOS:
!  \begin{enumerate}
!     \item The UNESCO equation of state computed using the 
!           potential-temperature-based bulk modulus from Jackett and 
!           McDougall, JTECH, Vol.12, pp 381-389, April, 1995.
!     \item The faster and more accurate alternative to the UNESCO eos
!           of McDougall, Wright, Jackett and Feistel (hereafter 
!           MWJF, 2001 submission to JTECH).
!     \item a simple linear EOS based on constant expansion coeffs
!  \end{enumerate}
!
! !REVISION HISTORY:
!  CVS:$Id: state_mod.F90,v 1.14 2003/02/11 23:33:15 pwjones Exp $
!  CVS:$Name:  $

! !USES:

	   use kinds_mod
!	   use constants
	   implicit none
	   private
	   save

! !PUBLIC MEMBER FUNCTIONS:

	   public :: state_ccsm,init_state

!EOP
!BOC
!-----------------------------------------------------------------------
!
!  valid ranges and pressure as function of depth
!
!-----------------------------------------------------------------------

	real (r8) :: & 
      	tmin, tmax,        &! valid temperature range
      	smin, smax          ! valid salinity    range

	   real (r8), dimension(:), allocatable :: & 
      	pressz              ! ref pressure (bars) at each level

!-----------------------------------------------------------------------
!
!  choices for eos type and valid range checks
!
!-----------------------------------------------------------------------

	   integer (int_kind), parameter :: &
      state_type_jmcd       = 1,    &! integer ids for state choice
      state_type_mwjf       = 2,    &
      state_type_linear     = 4

	   integer (int_kind) ::    &
      state_itype           ! input state type chosen

!-----------------------------------------------------------------------
!
!  UNESCO EOS constants and JMcD bulk modulus constants
!
!-----------------------------------------------------------------------

   !*** for density of fresh water (standard UNESCO)

	   real (r8), parameter ::           &
      unt0 =   999.842594d0,         &
      unt1 =  6.793952d-2,           &
      unt2 = -9.095290d-3,           &
      unt3 =  1.001685d-4,           &
      unt4 = -1.120083d-6,           &
      unt5 =  6.536332d-9

   !*** for dependence of surface density on salinity (UNESCO)

	   real (r8), parameter ::           &
      uns1t0 =  0.824493d0 ,         &
      uns1t3 = -8.2467d-7,           &
      uns1t1 = -4.0899d-3,           &
      uns1t2 =  7.6438d-5,           &
      uns1t4 =  5.3875d-9,           &
      unsqt0 = -5.72466d-3,          &
      unsqt1 =  1.0227d-4,           &
      unsqt2 = -1.6546d-6,           &
      uns2t0 =  4.8314d-4

   !*** from Table A1 of Jackett and McDougall

	   real (r8), parameter ::           &
      bup0s0t0 =  1.965933d+4,       &
      bup0s0t1 =  1.444304d+2,       &
      bup0s0t2 = -1.706103d0   ,     &
      bup0s0t3 =  9.648704d-3,       &
      bup0s0t4 = -4.190253d-5

	   real (r8), parameter ::           &
      bup0s1t0 =  5.284855d+1,       &
      bup0s1t1 = -3.101089d-1,       &
      bup0s1t2 =  6.283263d-3,       &
      bup0s1t3 = -5.084188d-5

	   real (r8), parameter ::           &
      bup0sqt0 =  3.886640d-1,       &
      bup0sqt1 =  9.085835d-3,       &
      bup0sqt2 = -4.619924d-4

	   real (r8), parameter ::           &
      bup1s0t0 =  3.186519d0   ,     &
      bup1s0t1 =  2.212276d-2,       &
      bup1s0t2 = -2.984642d-4,       &
      bup1s0t3 =  1.956415d-6 

	   real (r8), parameter ::           &
      bup1s1t0 =  6.704388d-3,       &
      bup1s1t1 = -1.847318d-4,       &
      bup1s1t2 =  2.059331d-7,       &
      bup1sqt0 =  1.480266d-4 

	   real (r8), parameter ::           &
      bup2s0t0 =  2.102898d-4,       &
      bup2s0t1 = -1.202016d-5,       &
      bup2s0t2 =  1.394680d-7,       &
      bup2s1t0 = -2.040237d-6,       &
      bup2s1t1 =  6.128773d-8,       &
      bup2s1t2 =  6.207323d-10

!-----------------------------------------------------------------------
!
!  MWJF EOS coefficients
!
!-----------------------------------------------------------------------

   !*** these constants will be used to construct the numerator
   !*** factor unit change (kg/m^3 -> g/cm^3) into numerator terms

	   real (r8), parameter ::                   &
      mwjfnp0s0t0 =   9.99843699d+2 * 1.d-3, &
      mwjfnp0s0t1 =   7.35212840d+0 * 1.d-3, &
      mwjfnp0s0t2 =  -5.45928211d-2 * 1.d-3, &
      mwjfnp0s0t3 =   3.98476704d-4 * 1.d-3, &
      mwjfnp0s1t0 =   2.96938239d+0 * 1.d-3, &
      mwjfnp0s1t1 =  -7.23268813d-3 * 1.d-3, &
      mwjfnp0s2t0 =   2.12382341d-3 * 1.d-3, &
      mwjfnp1s0t0 =   1.04004591d-2 * 1.d-3, &
      mwjfnp1s0t2 =   1.03970529d-7 * 1.d-3, &
      mwjfnp1s1t0 =   5.18761880d-6 * 1.d-3, &
      mwjfnp2s0t0 =  -3.24041825d-8 * 1.d-3, &
      mwjfnp2s0t2 =  -1.23869360d-11* 1.d-3

   !*** these constants will be used to construct the denominator

	   real (kind=r8), parameter ::       &
      mwjfdp0s0t0 =   1.0d0,          &
      mwjfdp0s0t1 =   7.28606739d-3,  &
      mwjfdp0s0t2 =  -4.60835542d-5,  &
      mwjfdp0s0t3 =   3.68390573d-7,  &
      mwjfdp0s0t4 =   1.80809186d-10, &
      mwjfdp0s1t0 =   2.14691708d-3,  &
      mwjfdp0s1t1 =  -9.27062484d-6,  &
      mwjfdp0s1t3 =  -1.78343643d-10, &
      mwjfdp0sqt0 =   4.76534122d-6,  &
      mwjfdp0sqt2 =   1.63410736d-9,  &
      mwjfdp1s0t0 =   5.30848875d-6,  &
      mwjfdp2s0t3 =  -3.03175128d-16, &
      mwjfdp3s0t1 =  -1.27934137d-17

   !*** MWJF numerator coefficients including pressure

	   real (r8) ::                                                        &
      mwjfnums0t0, mwjfnums0t1, mwjfnums0t2, mwjfnums0t3,              &
      mwjfnums1t0, mwjfnums1t1, mwjfnums2t0,                           &
      mwjfdens0t0, mwjfdens0t1, mwjfdens0t2, mwjfdens0t3, mwjfdens0t4, &
      mwjfdens1t0, mwjfdens1t1, mwjfdens1t3,                           &
      mwjfdensqt0, mwjfdensqt2

!-----------------------------------------------------------------------
!
!  parameters for linear eos
!
!-----------------------------------------------------------------------

	   real (r8), parameter ::       & 
      T_leos_ref = 19.0d0,       &! reference T for linear eos (deg C)
      S_leos_ref = 0.035d0,      &! reference S for linear eos (msu)
      rho_leos_ref = 1.025022d0, &! ref dens (g/cm3) at ref T,S and 0 bar
      alf = 2.55d-4,             &! expansion coeff -(drho/dT) (gr/cm^3/K)
      bet = 7.64d-1               ! expansion coeff (drho/dS) (gr/cm^3/msu)

!EOC
!***********************************************************************

	 contains

!***********************************************************************
!BOP
! !IROUTINE: state
! !INTERFACE:

	 subroutine state_ccsm(k, kk, TEMPK, SALTK, &
                  RHOOUT, MASK, fillValue, RHOFULL, DRHODT, DRHODS)

! !DESCRIPTION:
!  Returns the density of water at level k from equation of state
!  $\rho = \rho(d,\theta,S)$ where $d$ is depth, $\theta$ is
!  potential temperature, and $S$ is salinity. the density can be
!  returned as a perturbation (RHOOUT) or as the full density
!  (RHOFULL). Note that only the polynomial EOS choice will return
!  a perturbation density; in other cases the full density is returned
!  regardless of which argument is requested.
!
!  This routine also computes derivatives of density with respect
!  to temperature and salinity at level k from equation of state
!  if requested (ie the optional arguments are present).
!
!  If $k = kk$ are equal the density for level k is returned.
!  If $k \neq kk$ the density returned is that for a parcel
!  adiabatically displaced from level k to level kk.
!
! !REVISION HISTORY:
!  same as module

! !INPUT PARAMETERS:

	   integer (int_kind), intent(in) :: &
      k,                    &! depth level index
      kk                     ! level to which water is adiabatically 
                             ! displaced

	   real (r4), dimension(:,:), intent(in) :: & 
      TEMPK,             &! temperature (deg C) at level k
      SALTK               ! salinity    (msu)   at level k

	   logical, dimension(:,:), intent(in), optional :: &
      MASK                   ! for masking land points

	   real (r4), intent(in), optional :: &
      fillValue              ! optional value for filling land points
                             !   zero is used if no fill value supplied

! !OUTPUT PARAMETERS:

	   real (r8), dimension(:,:), optional, intent(out) :: & 
      RHOOUT,  &! perturbation density of water
      RHOFULL, &! full density of water
      DRHODT,  &! derivative of density with respect to temperature
      DRHODS    ! derivative of density with respect to salinity

!EOP
!BOC
!-----------------------------------------------------------------------
!
!  local variables:
!
!-----------------------------------------------------------------------

	   real (r8), dimension(size(TEMPK,dim=1),size(TEMPK,dim=2)) :: &
      TQ,SQ,             &! adjusted T,S
      BULK_MOD,          &! Bulk modulus
      RHO_S,             &! density at the surface
      DRDT0,             &! d(density)/d(temperature), for surface
      DRDS0,             &! d(density)/d(salinity   ), for surface
      DKDT,              &! d(bulk modulus)/d(pot. temp.)
      DKDS,              &! d(bulk modulus)/d(salinity  )
      SQR,DENOMK,        &! work arrays
      WORK1, WORK2, WORK3, WORK4, T2

	   real (r8) :: p,p2,fill !&
!      p, p2     &! temporary pressure scalars
!      fill       ! value to use for filling land points

!-----------------------------------------------------------------------
!
!  force T,S to be in valid range
!
!-----------------------------------------------------------------------

       TQ = min(DBLE(TEMPK),tmax)
       TQ = max(TQ,   tmin)

       SQ = min(DBLE(SALTK),smax)
       SQ = max(SQ,   smin)


       if (present(fillValue)) then
          fill = fillValue
       else
          fill = 0.d0
       endif

!-----------------------------------------------------------------------
!
!  now compute density or expansion coefficients
!
!-----------------------------------------------------------------------

       select case (state_itype)

!-----------------------------------------------------------------------
!
!  McDougall, Wright, Jackett, and Feistel EOS
!  test value : rho = 1.033213242 for
!  S = 35.0 PSU, theta = 20.0, pressz = 200.0
!
!-----------------------------------------------------------------------

       case (state_type_mwjf)


!	 TQ(230,150) = 20.
!	 SQ(230,150) = 35.
          p   = 10.d0*pressz(kk)
!	print*,'pressz(kk)=',pressz(kk)

!	  p = 200.
          SQ  = 1000.d0*SQ
	 SQ(230,150) = 35.
          SQR = sqrt(SQ)

      !***
      !*** first calculate numerator of MWJF density [P_1(S,T,p)]
      !***

          mwjfnums0t0 = mwjfnp0s0t0 + p*(mwjfnp1s0t0 + p*mwjfnp2s0t0)
          mwjfnums0t1 = mwjfnp0s0t1 
          mwjfnums0t2 = mwjfnp0s0t2 + p*(mwjfnp1s0t2 + p*mwjfnp2s0t2)
          mwjfnums0t3 = mwjfnp0s0t3
          mwjfnums1t0 = mwjfnp0s1t0 + p*mwjfnp1s1t0
          mwjfnums1t1 = mwjfnp0s1t1
          mwjfnums2t0 = mwjfnp0s2t0

          WORK1 = mwjfnums0t0 + TQ * (mwjfnums0t1 + TQ * (mwjfnums0t2 + &
              mwjfnums0t3 * TQ)) + SQ * (mwjfnums1t0 +              &
              mwjfnums1t1 * TQ + mwjfnums2t0 * SQ)

      !***
      !*** now calculate denominator of MWJF density [P_2(S,T,p)]
      !***

          mwjfdens0t0 = mwjfdp0s0t0 + p*mwjfdp1s0t0
          mwjfdens0t1 = mwjfdp0s0t1 + p**3 * mwjfdp3s0t1
          mwjfdens0t2 = mwjfdp0s0t2
          mwjfdens0t3 = mwjfdp0s0t3 + p**2 * mwjfdp2s0t3
          mwjfdens0t4 = mwjfdp0s0t4
          mwjfdens1t0 = mwjfdp0s1t0
          mwjfdens1t1 = mwjfdp0s1t1
          mwjfdens1t3 = mwjfdp0s1t3
          mwjfdensqt0 = mwjfdp0sqt0
          mwjfdensqt2 = mwjfdp0sqt2

          WORK2 = mwjfdens0t0 + TQ * (mwjfdens0t1 + TQ * (mwjfdens0t2 +    &
           TQ * (mwjfdens0t3 + mwjfdens0t4 * TQ))) +                   &
           SQ * (mwjfdens1t0 + TQ * (mwjfdens1t1 + TQ*TQ*mwjfdens1t3)+ &
           SQR * (mwjfdensqt0 + TQ*TQ*mwjfdensqt2))

          DENOMK = 1.d0/WORK2

      if (present(RHOOUT)) then
         RHOOUT  = merge(WORK1*DENOMK,fill, MASK)
!         RHOOUT  = WORK1*DENOMK
!	 print*,RHOOUT(230,150),TQ(230,150),SQ(230,150)

      endif

      if (present(RHOFULL)) then
         RHOFULL = merge(WORK1*DENOMK,fill,MASK)
      endif

      if (present(DRHODT)) then
         WORK3 = &! dP_1/dT
                 mwjfnums0t1 + TQ * (2.d0*mwjfnums0t2 +    &
                 3.d0*mwjfnums0t3 * TQ) + mwjfnums1t1 * SQ

         WORK4 = &! dP_2/dT
                 mwjfdens0t1 + SQ * mwjfdens1t1 +               &
                 TQ * (2.d0*(mwjfdens0t2 + SQ*SQR*mwjfdensqt2) +  &
                 TQ * (3.d0*(mwjfdens0t3 + SQ * mwjfdens1t3) +    &
                 TQ *  4.d0*mwjfdens0t4))

         DRHODT = merge((WORK3 - WORK1*DENOMK*WORK4)*DENOMK,fill,MASK)
      endif

      if (present(DRHODS)) then
         WORK3 = &! dP_1/dS
                 mwjfnums1t0 + mwjfnums1t1 * TQ + 2.d0*mwjfnums2t0 * SQ

         WORK4 = mwjfdens1t0 +   &! dP_2/dS
                 TQ * (mwjfdens1t1 + TQ*TQ*mwjfdens1t3) +   &
                 1.5d0*SQR*(mwjfdensqt0 + TQ*TQ*mwjfdensqt2)

         DRHODS = merge((WORK3 - WORK1*DENOMK*WORK4)*DENOMK * 1000.d0,&
		  fill,MASK)
      endif

!-----------------------------------------------------------------------
!
!  Jackett and McDougall EOS
!
!-----------------------------------------------------------------------

   case (state_type_jmcd)

      p   = pressz(kk)
      p2  = p*p

      SQ  = 1000.d0*SQ
      SQR = sqrt(SQ)
      T2  = TQ*TQ


      !***
      !*** first calculate surface (p=0) values from UNESCO eqns.
      !***

      WORK1 = uns1t0 + uns1t1*TQ + & 
             (uns1t2 + uns1t3*TQ + uns1t4*T2)*T2
      WORK2 = SQR*(unsqt0 + unsqt1*TQ + unsqt2*T2)

      RHO_S = unt1*TQ + (unt2 + unt3*TQ + (unt4 + unt5*TQ)*T2)*T2 &
                      + (uns2t0*SQ + WORK1 + WORK2)*SQ


      !***
      !*** now calculate bulk modulus at pressure p from 
      !*** Jackett and McDougall formula
      !***

      WORK3 = bup0s1t0 + bup0s1t1*TQ +                    &
             (bup0s1t2 + bup0s1t3*TQ)*T2 +                &
              p *(bup1s1t0 + bup1s1t1*TQ + bup1s1t2*T2) + &
              p2*(bup2s1t0 + bup2s1t1*TQ + bup2s1t2*T2)
      WORK4 = SQR*(bup0sqt0 + bup0sqt1*TQ + bup0sqt2*T2 + &
                   bup1sqt0*p)

      BULK_MOD  = bup0s0t0 + bup0s0t1*TQ +                    &
                  (bup0s0t2 + bup0s0t3*TQ + bup0s0t4*T2)*T2 + &
                  p *(bup1s0t0 + bup1s0t1*TQ +                &
                     (bup1s0t2 + bup1s0t3*TQ)*T2) +           &
                  p2*(bup2s0t0 + bup2s0t1*TQ + bup2s0t2*T2) + &
                  SQ*(WORK3 + WORK4)

      DENOMK = 1.d0/(BULK_MOD - p)

      !***
      !*** now calculate required fields
      !***

      if (present(RHOOUT)) then
         RHOOUT  = merge(((unt0 + RHO_S)*BULK_MOD*DENOMK)*1.d-3, &
                         fill, MASK)
      endif

      if (present(RHOFULL)) then
         RHOFULL = merge(((unt0 + RHO_S)*BULK_MOD*DENOMK)*1.d-3, &
                         fill, MASK)
      endif

      if (present(DRHODT)) then
         DRDT0 =  unt1 + 2.d0*unt2*TQ +                      &
                  (3.d0*unt3 + 4.d0*unt4*TQ + 5.d0*unt5*T2)*T2 + &
                  (uns1t1 + 2.d0*uns1t2*TQ +                 &
                   (3.d0*uns1t3 + 4.d0*uns1t4*TQ)*T2 +         &
                   (unsqt1 + 2.d0*unsqt2*TQ)*SQR )*SQ

         DKDT  = bup0s0t1 + 2.d0*bup0s0t2*TQ +                       &
                 (3.d0*bup0s0t3 + 4.d0*bup0s0t4*TQ)*T2 +               &
                 p *(bup1s0t1 + 2.d0*bup1s0t2*TQ + 3.d0*bup1s0t3*T2) + &
                 p2*(bup2s0t1 + 2.d0*bup2s0t2*TQ) +                  &
                 SQ*(bup0s1t1 + 2.d0*bup0s1t2*TQ + 3.d0*bup0s1t3*T2 +  &
                     p  *(bup1s1t1 + 2.d0*bup1s1t2*TQ) +             &
                     p2 *(bup2s1t1 + 2.d0*bup2s1t2*TQ) +             &
                     SQR*(bup0sqt1 + 2.d0*bup0sqt2*TQ))

         DRHODT = merge ((DENOMK*(DRDT0*BULK_MOD -                    &
                           pressz(kk)*(unt0+RHO_S)*DKDT*DENOMK))*1.d-3, &
                         fill, MASK)
      endif

      if (present(DRHODS)) then
         DRDS0  = 2.d0*uns2t0*SQ + WORK1 + 1.5d0*WORK2
         DKDS = WORK3 + 1.5d0*WORK4

         DRHODS = merge (DENOMK*(DRDS0*BULK_MOD -                    &
                          pressz(kk)*(unt0+RHO_S)*DKDS*DENOMK),       &
                         fill, MASK)

      endif
 
!-----------------------------------------------------------------------
!
!  linear EOS
!
!-----------------------------------------------------------------------

   case (state_type_linear)

      if (present(RHOOUT )) RHOOUT  = bet*(SALTK - S_leos_ref) - &
                                      alf*(TEMPK - T_leos_ref)
      if (present(RHOFULL)) RHOFULL = rho_leos_ref + & 
                                      bet*(SALTK - S_leos_ref) - &
                                      alf*(TEMPK - T_leos_ref)
      if (present(DRHODT )) DRHODT  = -alf
      if (present(DRHODS )) DRHODS  =  bet

!-----------------------------------------------------------------------

   end select

!-----------------------------------------------------------------------
!EOC

 end subroutine state_ccsm

!***********************************************************************
!BOP
! !IROUTINE: init_state
! !INTERFACE:

 subroutine init_state(state_choice, zt)

! !DESCRIPTION:
!  Initializes eos choice and initializes coefficients for
!  equation of state.
!
! !REVISION HISTORY:
!  same as module

! !INPUT PARAMETERS:

   character (*), intent(in) :: &
      state_choice          ! choice of which EOS to use
                            ! valid choices are: mwjf, jmcd, linear

   real (r4), dimension(:), intent(in) :: &
      zt                    ! depth (cm) of each k level

!EOP
!BOC
!-----------------------------------------------------------------------
!
!  local variables
!
!-----------------------------------------------------------------------

   integer (int_kind) ::  & 
      k                    ! vertical loop index

!-----------------------------------------------------------------------
!
!  set EOS type from input choice
!
!-----------------------------------------------------------------------

   select case (state_choice(1:4))
   case ('jmcd')
      state_itype = state_type_jmcd
   case ('mwjf')
      state_itype = state_type_mwjf
   case ('line')
      state_itype = state_type_linear
   case default
      stop 'unknown choice for EOS'
   end select

!-----------------------------------------------------------------------
!
!  calculate pressure as function of depth
!
!-----------------------------------------------------------------------

   allocate(pressz(size(zt)))

   do k=1,size(zt)
      pressz(k) = pressure(zt(k)*0.01d0)  ! convert depth to meters
   end do

!-----------------------------------------------------------------------
!
!  initialize various arrays, constants for each state type
!
!-----------------------------------------------------------------------

   select case (state_itype)

!-----------------------------------------------------------------------
!
!  McDougall, Wright, Jackett, and Feistel
!
!-----------------------------------------------------------------------

   case (state_type_mwjf)

      tmin =  -2.0d0  ! limited   on the low  end
      tmax = 999.0d0  ! unlimited on the high end
      smin =   0.0d0  ! limited   on the low  end
      smax = 0.999d0  ! unlimited on the high end

!-----------------------------------------------------------------------
!
!  Jackett and McDougall
!
!-----------------------------------------------------------------------

   case (state_type_jmcd)

      tmin = -2.0d0  ! valid pot. temp. range for level k
      tmax = 40.0d0 
      smin =  0.0d0  ! valid salinity   range for level k
      smax = 0.042d0 

!-----------------------------------------------------------------------
!
!  linear EOS - intialize valid range
!
!-----------------------------------------------------------------------

   case (state_type_linear)

      tmin = -2.0d0  ! valid pot. temp. range for level k
      tmax = 40.0d0 
      smin =  0.0d0  ! valid salinity   range for level k
      smax = 0.042d0 

   end select

!-----------------------------------------------------------------------
!EOC

 end subroutine init_state

!***********************************************************************
!BOP
! !IROUTINE: pressure
! !INTERFACE:

 function pressure(depth)

! !DESCRIPTION:
!  This function computes pressure in bars from depth in meters
!  using a mean density derived from depth-dependent global 
!  average temperatures and salinities from Levitus 1994, and 
!  integrating using hydrostatic balance.
!
!  References:
!
!     Levitus, S., R. Burgett, and T.P. Boyer, World Ocean Atlas 
!          1994, Volume 3: Salinity, NOAA Atlas NESDIS 3, US Dept. of 
!          Commerce, 1994.
!
!     Levitus, S. and T.P. Boyer, World Ocean Atlas 1994, 
!          Volume 4: Temperature, NOAA Atlas NESDIS 4, US Dept. of 
!          Commerce, 1994.
!
!     Dukowicz, J. K., 2000: Reduction of Pressure and Pressure
!          Gradient Errors in Ocean Simulations, J. Phys. Oceanogr.,
!          submitted.
!
! !REVISION HISTORY:
!  same as module

! !INPUT PARAMETERS:

   real (r8), intent(in) :: depth    ! depth in meters

! !OUTPUT PARAMETERS:

   real (r8) :: pressure   ! pressure [bars]

!EOP
!BOC
!-----------------------------------------------------------------------
!
!  convert depth in meters to pressure in bars
!
!-----------------------------------------------------------------------

   pressure = 0.059808d0*(exp(-0.025d0*depth) - 1.d0)     &
            + 0.100766d0*depth + 2.28405d-7*depth**2

!-----------------------------------------------------------------------
!EOC

 end function pressure

!***********************************************************************

 end module state_ccsm_mod

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

program poptrans
  ! Calculate POP zonal mean temperature, from
  ! PCM1/PCTM/CCSM2 POP history tapes
  !
  implicit none
  include 'netcdf.inc'
  !
  ! f90 poptrans.f90 -L/contrib/lib -I/contrib/include -lnetcdf
  ! modified by tc 3/1999 - psi computed from the w method
  ! modified by gs 6/1999 - f90 and output is now netCDF
  ! modified by gs 1/2000 - do each level of U,V,T one at a time to fit
  !                         into memory of T3E
  ! modified by gs 4/2001 - get grid info from pcm1_grid.nc file
  ! Number of single-field format input files per analysis run, i.e.:
  ! 1: b40.20th.track1.1deg.005.pop.h.PD.185001-185912.nc
  ! 2: b40.20th.track1.1deg.005.pop.h.QFLUX.185001-185912.nc
  ! 3: b40.20th.track1.1deg.005.pop.h.SALT.185001-185912.nc
  ! 4: b40.20th.track1.1deg.005.pop.h.SFWF.185001-185912.nc
  ! 5: b40.20th.track1.1deg.005.pop.h.SHF.185001-185912.nc
  ! 6: b40.20th.track1.1deg.005.pop.h.SSH.185001-185912.nc
  ! 7: b40.20th.track1.1deg.005.pop.h.TEMP.185001-185912.nc
  !
  integer,parameter::nphi=360
  integer,parameter::nd =  3,nv = 28,ndv=nd+nv

  real   ,parameter::phi_start=-89.75,phi_end=89.75
  real   ,parameter::spval=1.e30
  real   ,parameter::cal2joule = 4.1868
  !
  integer::varxtype,varndims,varnatts,status,itime,imt,jmt,km,ocnncid
  integer::ocnncid_pd,ocnncid_qflux,ocnncid_salt,ocnncid_sfwf,ocnncid_shf,ocnncid_ssh,ocnncid_temp
  integer::nvars_pd,nvars_qflux,nvars_salt,nvars_sfwf,nvars_shf,nvars_ssh,nvars_temp
  integer::ndims_pd,ndims_qflux,ndims_salt,ndims_sfwf,ndims_shf,ndims_ssh,ndims_temp
  integer::timelen_pd,timelen_qflux,timelen_salt,timelen_sfwf,timelen_shf,timelen_ssh,timelen_temp
  integer::tranncid,ngatts,unlimdimid
  integer::latd,levd,timd,vdim,varid,gridid,nvars,ndims
  integer::i,j,k,l,m,n,jc,ip1,im1,jp1,jm1,iv
  integer,dimension(ndv)::varlev,vrdims
  integer,dimension(4)::istart,icount,vardimids
  integer,dimension(3)::ostart,ocount,vdims
  integer,dimension(20)::nc_dimlen
  integer::nnn
  !
  real::pi,r2d,dphi
  real::wtkb,wtk,fuew,fuww,fvnw,fvsw,work
  real::fuetw,fuwtw,fvntw,fvstw
  integer,dimension(:,:),allocatable::amaskt,imaskt,pmaskt,smaskt,kmu,kmt,region_mask
  real,dimension(:,:),allocatable::ulat,htn,hte,dxu,dyu,tlon,tlat,tarea
  real,dimension(:,:),allocatable::saln,dens,t,shf,sfwf,ssh,qflx
  real,dimension(:,:),allocatable::gt1,at1,it1,pt1,gs1,as1,is1,ps1
  real,dimension(:,:),allocatable::gt2,at2,it2,pt2,gd1,ad1,id1,pd1
  real,dimension(:),allocatable::ght,aht,iht,pht,gsf,asf,isf,psf
  real,dimension(:),allocatable::gsh,ash,ish,psh
  real,dimension(:),allocatable::areag,areaa,areai,areap
  real,dimension(:,:,:),allocatable::w,htw,fue,fvn,fuet,fvnt
  real,dimension(:),allocatable::psia,mhta,psii,mhti,psip,mhtp
  real,dimension(:),allocatable::dz,depth
  real,dimension(nphi)::latr,htrans
  real,dimension(5000)::time_pd,time_qflux,time_salt,time_sfwf,time_shf,time_ssh,time_temp,time
  !
  character(len=132)::varname,title,ncfile,nc_dimname,gridfile
  character(len=132)::infile_pd,infile_qflux,infile_salt,infile_sfwf,infile_shf,infile_ssh,infile_temp
  character(len=132),dimension(ndv)::varnam,vrunit,vrlong,vrtype,vrgrid
  character(len=132),dimension(ndv)::varstr
  !
  logical::does_exist
  !
  varstr = (/&
       !VARNAM     Lv VRLONG                             T  D  Gr VRUNITS
  'lat         1 Latitude                           F  1  XX degrees_north        ',&
       'lev         1 Level                              F  1  XX m                    ',&
       'time        1 Time                               F  1  XX days since 0000-01-01',&
       'gtemp       1 Global zonal mean temperature      F  3  TS degree C             ',&
       'atemp       1 Atlantic zonal mean temperature    F  3  TS degree C             ',&
       'itemp       1 Indian zonal mean temperature      F  3  TS degree C             ',&
       'ptemp       1 Pacific zonal mean temperature     F  3  TS degree C             ',&
       'gsalt       1 Global zonal mean salinity         F  3  TS g/kg                 ',&
       'asalt       1 Atlantic zonal mean salinity       F  3  TS g/kg                 ',&
       'isalt       1 Indian zonal mean salinity         F  3  TS g/kg                 ',&
       'psalt       1 Pacific zonal mean salinity        F  3  TS g/kg                 ',&
       'gdens       1 Global zonal mean density          F  3  TS kg/m^3               ',&
       'adens       1 Atlantic zonal mean density        F  3  TS kg/m^3               ',&
       'idens       1 Indian zonal mean density          F  3  TS kg/m^3               ',&
       'pdens       1 Pacific zonal mean density         F  3  TS kg/m^3               ',&
       'gsht        1 Global zonal mean surf. ht flux    F  2  TS w/m^2                ',&
       'asht        1 Atlantic zonal mean surf. ht flux  F  2  TS w/m^2                ',&
       'psht        1 Pacific zonal mean surf. ht flux   F  2  TS w/m^2                ',&
       'isht        1 Indian zonal mean surf. ht flux    F  2  TS w/m^2                ',&
       'gsfwf       1 Global zonal mean sf frshwt flx    F  2  TS mm/day               ',&
       'asfwf       1 Atlantic zonal mean sf frshwt flx  F  2  TS mm/day               ',&
       'psfwf       1 Pacific zonal mean sf frshwt flx   F  2  TS mm/day               ',&
       'isfwf       1 Indian zonal mean sf frshwt flx    F  2  TS mm/day               ',&
       'gssh        1 Global zonal mean sea surf ht      F  2  TS cm                   ',&
       'assh        1 Atlantic zonal mean sea surf ht    F  2  TS cm                   ',&
       'pssh        1 Pacific zonal mean sea surf ht     F  2  TS cm                   ',&
       'issh        1 Indian zonal mean sea surf ht      F  2  TS cm                   ',&
       'areag       1 global ocean area by latitude      F  2  TS cm^2                 ',&
       'areaa       1 atlantic ocean area by latitude    F  2  TS cm^2                 ',&
       'areai       1 Indian ocean area by latitude      F  2  TS cm^2                 ',&
       'areap       1 Pacific ocean area by latitude     F  2  TS cm^2                 '/)
  !
  write(*,'(''Input PD file: '',$)')
  read (*,'(a)') infile_pd
  write(*,*)
  call check_exists(infile_pd)
  !
  write(*,'(''Input QFLUX file: '',$)')
  read (*,'(a)') infile_qflux
  write(*,*)
  call check_exists(infile_qflux)
  !
  write(*,'(''Input SALT file: '',$)')
  read (*,'(a)') infile_salt
  write(*,*)
  call check_exists(infile_salt)
  !
  write(*,'(''Input SFWF file: '',$)')
  read (*,'(a)') infile_sfwf
  write(*,*)
  call check_exists(infile_sfwf)
  !
  write(*,'(''Input SHF file: '',$)')
  read (*,'(a)') infile_shf
  write(*,*)
  call check_exists(infile_shf)
  !
  write(*,'(''Input SSH file: '',$)')
  read (*,'(a)') infile_ssh
  write(*,*)
  call check_exists(infile_ssh)
  !
  write(*,'(''Input TEMP file: '',$)')
  read (*,'(a)') infile_temp
  write(*,*)
  call check_exists(infile_temp)
  write(*,'(7(a,/))') trim(infile_pd),trim(infile_qflux),trim(infile_salt),trim(infile_sfwf),trim(infile_shf),trim(infile_ssh),trim(infile_temp)
  !
  status = nf_open(infile_pd,nf_nowrite,ocnncid_pd)                        ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_inq(ocnncid_pd,ndims_pd,nvars_pd,ngatts,unlimdimid)          ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_open(infile_qflux,nf_nowrite,ocnncid_qflux)                  ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_inq(ocnncid_qflux,ndims_qflux,nvars_qflux,ngatts,unlimdimid) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_open(infile_salt,nf_nowrite,ocnncid_salt)                    ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_inq(ocnncid_salt,ndims_salt,nvars_salt,ngatts,unlimdimid)    ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_open(infile_sfwf,nf_nowrite,ocnncid_sfwf)                    ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_inq(ocnncid_sfwf,ndims_sfwf,nvars_sfwf,ngatts,unlimdimid)    ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_open(infile_shf,nf_nowrite,ocnncid_shf)                      ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_inq(ocnncid_shf,ndims_shf,nvars_shf,ngatts,unlimdimid)       ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_open(infile_ssh,nf_nowrite,ocnncid_ssh)                      ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_inq(ocnncid_ssh,ndims_ssh,nvars_ssh,ngatts,unlimdimid)       ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_open(infile_temp,nf_nowrite,ocnncid_temp)                    ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_inq(ocnncid_temp,ndims_temp,nvars_temp,ngatts,unlimdimid)    ; if (status /= nf_noerr) write(*,*) nf_strerror(status)

  ! Find out I and J and K dimensions
  do i = 1,ndims_pd
     status = nf_inq_dim(ocnncid_pd,i,nc_dimname,nc_dimlen(i))
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     if (trim(nc_dimname) == 'lon')  imt = nc_dimlen(i)
     if (trim(nc_dimname) == 'lat')  jmt = nc_dimlen(i)
     if (trim(nc_dimname) == 'lev')   km = nc_dimlen(i)
     if (trim(nc_dimname) == 'nlon') imt = nc_dimlen(i)
     if (trim(nc_dimname) == 'nlat') jmt = nc_dimlen(i)
     if (trim(nc_dimname) == 'z_t')   km = nc_dimlen(i)
  enddo
  !
  allocate(amaskt(imt,jmt),imaskt(imt,jmt),pmaskt(imt,jmt),smaskt(imt,jmt))
  allocate(kmu(imt,jmt),kmt(imt,jmt),region_mask(imt,jmt))
  allocate(ulat(imt,jmt),htn(imt,jmt),hte(imt,jmt))
  allocate(dxu(imt,jmt),dyu(imt,jmt),tlon(imt,jmt),tlat(imt,jmt),tarea(imt,jmt))
  allocate(saln(imt,jmt),dens(imt,jmt),t(imt,jmt))
  allocate(shf(imt,jmt),sfwf(imt,jmt),ssh(imt,jmt),qflx(imt,jmt))
  allocate(gt1(km,nphi),at1(km,nphi),gt2(km,nphi),at2(km,nphi))
  allocate(it1(km,nphi),pt1(km,nphi),it2(km,nphi),pt2(km,nphi))
  allocate(gd1(km,nphi),ad1(km,nphi),gs1(km,nphi),as1(km,nphi))
  allocate(id1(km,nphi),pd1(km,nphi),is1(km,nphi),ps1(km,nphi))
  allocate(ght(nphi),aht(nphi),pht(nphi),iht(nphi))
  allocate(gsf(nphi),asf(nphi),psf(nphi),isf(nphi))
  allocate(gsh(nphi),ash(nphi),psh(nphi),ish(nphi))
  allocate(areag(nphi),areaa(nphi),areai(nphi),areap(nphi))
  allocate(w(imt,jmt,km),htw(imt,jmt,km),fue(imt,jmt,km),fvn(imt,jmt,km))
  allocate(fuet(imt,jmt,km),fvnt(imt,jmt,km))
  allocate(psia(km),mhta(km),psii(km),mhti(km),psip(km),mhtp(km))
  allocate(dz(km),depth(km))
  gt1 = 0.;at1 = 0.;it1 = 0.;pt1 = 0.
  gt2 = 0.;at2 = 0.;it2 = 0.;pt2 = 0.
  gs1 = 0.;as1 = 0.;is1 = 0.;ps1 = 0.
  gd1 = 0.;ad1 = 0.;id1 = 0.;pd1 = 0.
  ght = 0.;aht = 0.;iht = 0.;pht = 0.
  gsf = 0.;asf = 0.;isf = 0.;psf = 0.
  gsh = 0.;ash = 0.;ish = 0.;psh = 0.

  ! Find out how many time samples there are in each file
  do i = 1,nvars_pd
     status = nf_inq_var(ocnncid_pd,i,varname,varxtype,varndims,vardimids,varnatts)
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     if ((trim(varname) == 'time').or.(trim(varname) ==  'TIME')) then
        status = nf_inq_dim(ocnncid_pd,unlimdimid,varname,timelen_pd) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
        status = nf_get_var_real(ocnncid_pd,i,time_pd)                ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
     endif
  enddo
  do i = 1,nvars_qflux
     status = nf_inq_var(ocnncid_qflux,i,varname,varxtype,varndims,vardimids,varnatts)
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     if ((trim(varname) == 'time').or.(trim(varname) ==  'TIME')) then
        status = nf_inq_dim(ocnncid_qflux,unlimdimid,varname,timelen_qflux) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
        status = nf_get_var_real(ocnncid_qflux,i,time_qflux)                ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
     endif
  enddo
  do i = 1,nvars_salt
     status = nf_inq_var(ocnncid_salt,i,varname,varxtype,varndims,vardimids,varnatts)
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     if ((trim(varname) == 'time').or.(trim(varname) ==  'TIME')) then
        status = nf_inq_dim(ocnncid_salt,unlimdimid,varname,timelen_salt) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
        status = nf_get_var_real(ocnncid_salt,i,time_salt)                ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
     endif
  enddo
  do i = 1,nvars_sfwf
     status = nf_inq_var(ocnncid_sfwf,i,varname,varxtype,varndims,vardimids,varnatts)
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     if ((trim(varname) == 'time').or.(trim(varname) ==  'TIME')) then
        status = nf_inq_dim(ocnncid_sfwf,unlimdimid,varname,timelen_sfwf) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
        status = nf_get_var_real(ocnncid_sfwf,i,time_sfwf)                ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
     endif
  enddo
  do i = 1,nvars_shf
     status = nf_inq_var(ocnncid_shf,i,varname,varxtype,varndims,vardimids,varnatts)
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     if ((trim(varname) == 'time').or.(trim(varname) ==  'TIME')) then
        status = nf_inq_dim(ocnncid_shf,unlimdimid,varname,timelen_shf) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
        status = nf_get_var_real(ocnncid_shf,i,time_shf)                ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
     endif
  enddo
  do i = 1,nvars_ssh
     status = nf_inq_var(ocnncid_ssh,i,varname,varxtype,varndims,vardimids,varnatts)
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     if ((trim(varname) == 'time').or.(trim(varname) ==  'TIME')) then
        status = nf_inq_dim(ocnncid_ssh,unlimdimid,varname,timelen_ssh) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
        status = nf_get_var_real(ocnncid_ssh,i,time_ssh)                ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
     endif
  enddo
  do i = 1,nvars_temp
     status = nf_inq_var(ocnncid_temp,i,varname,varxtype,varndims,vardimids,varnatts)
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     if ((trim(varname) == 'time').or.(trim(varname) ==  'TIME')) then
        status = nf_inq_dim(ocnncid_temp,unlimdimid,varname,timelen_temp) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
        status = nf_get_var_real(ocnncid_temp,i,time_temp)                ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
     endif
  enddo
  write(*,'(7i6)') timelen_pd,timelen_qflux,timelen_salt,timelen_sfwf,timelen_shf,timelen_ssh,timelen_temp
  !
  istart =(/   1,  1,  1,  1/)
  icount =(/ imt,jmt,  1,  1/)
  ostart =(/   1,  1,  1/)
  ocount =(/nphi, km,  1/)
  !
  pi=atan(1.)*4.
  r2d=180./pi
  !
  if (jmt == 288) gridfile = 'pcm1_grid.nc'
  if (jmt == 320) gridfile = 'pcm2_grid.nc'
  if (jmt == 384) gridfile = 'ccsm2_ocn.nc'
  if (km.eq.60) then
     gridfile = infile_pd
  else
     inquire(file=trim(gridfile),exist=does_exist)
     if (.not.(does_exist)) then
        write(*,*) 'Need to link in ',trim(gridfile),' as follows: '
        write(*,*) 'ln -s /fs/cgd/data0/strandwg/ferret/data/',trim(gridfile),' .'
        write(*,*) 'Stopping.'
        stop
     endif
  endif
  !
  ! Get grid info
  !
  status = nf_open(trim(gridfile),nf_nowrite,gridid)    ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_inq(gridid,ndims,nvars,ngatts,unlimdimid) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
  do i = 1,nvars
     status = nf_inq_var(gridid,i,varname,varxtype,varndims,vardimids,varnatts)
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     select case (trim(varname))
     case ('kmt','KMT')
        status = nf_get_var_int(gridid,i,kmt)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
     case ('amaskm')
        status = nf_get_var_int(gridid,i,amaskt)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
     case ('imaskt')
        status = nf_get_var_int(gridid,i,imaskt)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
     case ('pmaskt')
        status = nf_get_var_int(gridid,i,pmaskt)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
     case ('smaskt')
        status = nf_get_var_int(gridid,i,smaskt)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
     case ('REGION_MASK')
        status = nf_get_var_int(gridid,i,region_mask)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
        amaskt = 0 ; imaskt = 0 ; pmaskt = 0 ; smaskt = 0
        where (region_mask == 2) ; pmaskt = 1 ; endwhere
        where (region_mask == 3) ; imaskt = 1 ; endwhere
        where (region_mask == 6) ; amaskt = 1 ; endwhere
        where (region_mask == 8) ; amaskt = 1 ; endwhere
	where (region_mask == 9) ; amaskt = 1 ; endwhere
        where (region_mask == 1) ; smaskt = 1 ; endwhere
     case ('lat','ULAT')
        status = nf_get_var_real(gridid,i,ulat)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
        ulat = ulat / r2d
     case ('lon','TLON','tlong','TLONG')
        status = nf_get_var_real(gridid,i,tlon)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
        !        tlon = tlon / r2d
     case ('htn','HTN')
        status = nf_get_var_real(gridid,i,htn)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
     case ('hte','HTE')
        status = nf_get_var_real(gridid,i,hte)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
     case ('dz')
        status = nf_get_var_real(gridid,i,dz)
        if (status /= nf_noerr) write(*,*) nf_strerror(status)
     case default
     end select
  enddo
  status = nf_close(gridid)
  if (status /= nf_noerr) write(*,*) nf_strerror(status)
  !
  do j=1,jmt
     do i=1,imt
        im1=mod(i-2+imt,imt)+1
        ip1=mod(i,imt)+1
        jm1=mod(j-2+jmt,jmt)+1
        jp1=mod(j,jmt)+1
        kmu(i,j)=min(kmt(i,j),kmt(ip1,j),kmt(i,jp1),kmt(ip1,jp1))
        tlat(i,j)=0.25*(ulat(i,j)+ulat(im1,j)+ulat(i,jm1)+ulat(im1,jm1))*r2d
        tarea(i,j)=0.25*(htn(i,j)+htn(i,jm1))*(hte(i,j)+hte(im1,j))
        dxu(i,j)=0.5*(htn(i,j)+htn(ip1,j))
        dyu(i,j)=0.5*(hte(i,j)+hte(i,jp1))
     enddo
  enddo

  depth(1)=dz(1)
  do k=2,km
     depth(k)=(depth(k-1)+dz(k))
  enddo
  depth = depth/100 ! cm to m

  dphi = (phi_end - phi_start)/float(nphi - 1)
  do n = 1,nphi
     latr(n) = (phi_start+float(n-1)*dphi)
  enddo
  write(*,*) 'Grid information read and computed successfully.'

  ! Create new netCDF file for transports
  ncfile = 'TSDsurf_'//trim(infile_pd)
  do i = 1,ndv
     read(varstr(i),'(a10,i3,1x,a34,1x,a1,2x,i1,2x,a2,1x,a)') &
          varnam(i),varlev(i),vrlong(i),vrtype(i),vrdims(i),vrgrid(i),vrunit(i)
  enddo
  status = nf_create(trim(ncfile),nf_clobber,tranncid)
  !
  status = nf_def_dim(tranncid,varnam(1),nphi,latd)
  status = nf_def_dim(tranncid,varnam(2),km,levd)
  status = nf_def_dim(tranncid,varnam(3),NF_UNLIMITED,timd)
  !
  do i = 1,nd
     if (i == 1) vdim = latd
     if (i == 2) vdim = levd
     if (i == 3) vdim = timd
     status = nf_def_var(tranncid,varnam(i),ncfloat,vrdims(i),vdim,varid)
     status = nf_put_att_text(tranncid,varid,'units',len_trim(vrunit(i)),vrunit(i))
     status = nf_put_att_text(tranncid,varid,'long_name',len_trim(vrlong(i)),vrlong(i))
     if (i == 2) status = nf_put_att_text(tranncid,varid,'positive',4,'down')
  enddo
  !
  do i = 1,nv
     j = (i+nd)
     vdims(1) = latd
     if (vrdims(j) == 3) then
        vdims(2) = levd
        vdims(3) = timd
     else
        vdims(2) = timd
     endif
     status = nf_def_var(tranncid,varnam(j),ncfloat,vrdims(j),vdims,varid)
     status = nf_put_att_text(tranncid,varid,'units',len_trim(vrunit(j)),vrunit(j))
     status = nf_put_att_text(tranncid,varid,'long_name',len_trim(vrlong(j)),vrlong(j))
     status = nf_put_att_real(tranncid,varid,'missing_value',ncfloat,1,spval)
     status = nf_put_att_real(tranncid,varid,'_FillValue',ncfloat,1,spval)
  enddo
  !
  title  = 'zonal mean fields from '//trim(infile_pd)
  status = nf_put_att_text(tranncid,nf_global,'title',len_trim(title),title)
  status = nf_enddef(tranncid)
  !
  status = nf_inq_varid(tranncid,trim(varnam(1)),varid)
  status = nf_put_var_real(tranncid,varid,latr)
  if (status /= nf_noerr) write(*,*) nf_strerror(status)
  status = nf_inq_varid(tranncid,trim(varnam(2)),varid)
  status = nf_put_var_real(tranncid,varid,depth)
  if (status /= nf_noerr) write(*,*) nf_strerror(status)
  !
  ! Now do the calculation
  !
  do itime = 1,timelen_pd
     do k=1,km
        ! get T,S
        saln = spval ; dens = spval ; t = spval
        ssh  = spval ; sfwf = spval ; shf = spval ; qflx = spval
        istart(3) = k ; istart(4) = itime
        !
        do iv = 1,nvars_pd
           status = nf_inq_var(ocnncid_pd,iv,varname,varxtype,varndims,vardimids,varnatts) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
           select case(trim(varname))
           case ('pd','PD')
              status = nf_get_vara_real(ocnncid_pd,iv,istart,icount,dens) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
           case default
           end select
        enddo
        do iv = 1,nvars_temp
           status = nf_inq_var(ocnncid_temp,iv,varname,varxtype,varndims,vardimids,varnatts) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
           select case(trim(varname))
           case ('temp','TEMP')
              status = nf_get_vara_real(ocnncid_temp,iv,istart,icount,t)
              if (status /= nf_noerr) write(*,*) nf_strerror(status)
           case default
           end select
        enddo
        do iv = 1,nvars_salt
           status = nf_inq_var(ocnncid_salt,iv,varname,varxtype,varndims,vardimids,varnatts) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
           select case(trim(varname))
           case ('salt','SALT','S','s')
              status = nf_get_vara_real(ocnncid_salt,iv,istart,icount,saln)
              if (status /= nf_noerr) write(*,*) nf_strerror(status)
           case default
           end select
        enddo
        if (k==1) then
           istart(3) = itime
           do iv = 1,nvars_shf
              status = nf_inq_var(ocnncid_shf,iv,varname,varxtype,varndims,vardimids,varnatts) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
              select case(trim(varname))
	      case ('shf','SHF')
	         status = nf_get_vara_real(ocnncid_shf,iv,istart,icount,shf)
                 if (status /= nf_noerr) write(*,*) nf_strerror(status)
              case default
              end select
           enddo
           do iv = 1,nvars_ssh
              status = nf_inq_var(ocnncid_ssh,iv,varname,varxtype,varndims,vardimids,varnatts) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
              select case(trim(varname))
	      case ('ah1','SSH')
		 status = nf_get_vara_real(ocnncid_ssh,iv,istart,icount,ssh)
                 if (status /= nf_noerr) write(*,*) nf_strerror(status)
              case default
              end select
           enddo
           do iv = 1,nvars_sfwf
              status = nf_inq_var(ocnncid_sfwf,iv,varname,varxtype,varndims,vardimids,varnatts) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
              select case(trim(varname))
	      case ('ssf','SFWF')
		 status = nf_get_vara_real(ocnncid_sfwf,iv,istart,icount,sfwf)
                 if (status /= nf_noerr) write(*,*) nf_strerror(status)
              case default
              end select
           enddo
           do iv = 1,nvars_qflux
              status = nf_inq_var(ocnncid_qflux,iv,varname,varxtype,varndims,vardimids,varnatts) ; if (status /= nf_noerr) write(*,*) nf_strerror(status)
              select case(trim(varname))
	      case ('QFLUX')
		 status = nf_get_vara_real(ocnncid_qflux,iv,istart,icount,qflx)
                 if (status /= nf_noerr) write(*,*) nf_strerror(status)
              case default
              end select
           enddo
        end if
        if (jmt == 288) then
           saln=saln*1000.
           !	print*,'before density',k,t(25,150),saln(25,150),dens(25,150)
           call density(imt,jmt,t,saln,dens,kmt,k,0.)
        end if
        !        if (jmt == 320 .and. k == 1 ) then
        !       qflx=qflx/3.34e5
        !       sfwf=(sfwf-qflx)*8.64*1.e4   !convert to mm/day
        !       end if

        !        if (k.eq.1) print*,'sfwf(200,200)=',sfwf(200,200),'shf(200,200)=',shf(200,200)

        !        print*,'after density',k,t(25,150),saln(25,150),dens(25,150)
        ! Clean them up a wee bit
        where (abs(dens)>1.e10) ; dens = 0. ; end where
        where (abs(saln)>1.e10) ; saln = 0. ; end where
        where (abs(t)>1.e10) ; t = 0. ; end where
        if (k == 1) then
           where (abs(ssh)>1.e10) ; ssh = 0. ; end where
           where (abs(shf)>1.e10) ; shf = 0. ; end where
           where (abs(qflx)>1.e10) ; shf = 0. ; end where
           where (abs(sfwf)>1.e10) ; sfwf = 0. ; end where
           where (kmt<k) ; ssh(:,:) = 0.; shf(:,:) = 0.  ; end where
           where (kmt<k) ; sfwf(:,:) = 0.; end where
        end if

        where (kmt<k) ; dens(:,:) = 0. ; saln(:,:) = 0. ; end where
        where (kmt<k) ; t(:,:) = 0. ; end where

        if (jmt == 320 .and. k == 1 ) then
           qflx=qflx/3.34e5
           sfwf=(sfwf-qflx)*8.64*1.e4   !convert to mm/day
        end if
        !        if (k.eq.1) print*,'sfwf(200,200)=',sfwf(200,200),'shf(200,200)=',shf(200,200)
        ! precompute flux information
        ! compute dxu,dyu,fue,fvn like wcalc in pop
        ! fue, fvn is the flux through the east and north edge, u*dy or v*dx
        do j=1,jmt
           do i=1,imt
              im1=mod(i-2+imt,imt)+1
              ip1=mod(i,imt)+1
              jm1=mod(j-2+jmt,jmt)+1
              jp1=mod(j,jmt)+1
              !
              fuet(i,j,k)=t(i,j)*tarea(i,j)    !temperature
              fue(i,j,k)=saln(i,j)*tarea(i,j)     !salinity
     	      fvn(i,j,k)=dens(i,j)*tarea(i,j)     !density
           enddo
        enddo
        if (k == 1) then
           do j=1,jmt
              do i=1,imt
                 fvnt(i,j,1)=shf(i,j)*tarea(i,j)
                 fvnt(i,j,2)=sfwf(i,j)*tarea(i,j)
                 fvnt(i,j,3)=ssh(i,j)*tarea(i,j)
              enddo
           enddo
        endif
     enddo ! do k = 1,km
     print*,"test case"
     !
     gt1=0.;gt2=0.;gs1=0.;gd1=0.
     at1=0.;at2=0.;as1=0.;ad1=0.
     it1=0.;it2=0.;is1=0.;id1=0.
     pt1=0.;pt2=0.;ps1=0.;pd1=0.

     !
     do n = 2,nphi
        !
  	nnn=0
        do j=1,jmt
           do i=1,imt
              if (tlat(i,j)<latr(n).and.tlat(i,j)>=latr(n-1)) then
                 nnn=nnn+1
                 do k=1,km
                    if (k<=kmt(i,j)) then
                       gt1(k,n)=gt1(k,n)+fuet(i,j,k)
                       gt2(k,n)=gt2(k,n)+tarea(i,j)
                       gs1(k,n)=gs1(k,n)+fue(i,j,k)
                       gd1(k,n)=gd1(k,n)+fvn(i,j,k)
		       if (k == 1) then
                          ght(n)=ght(n)+fvnt(i,j,1)
                          gsf(n)=gsf(n)+fvnt(i,j,2)
                          gsh(n)=gsh(n)+fvnt(i,j,3)
	               end if
                       if (amaskt(i,j) == 1 .or. (smaskt(i,j)==1.and.(tlon(i,j)>290. .or. tlon(i,j) <= 20.))) then
                          at1(k,n)=at1(k,n)+fuet(i,j,k)
                          at2(k,n)=at2(k,n)+tarea(i,j)
                          as1(k,n)=as1(k,n)+fue(i,j,k)
                          ad1(k,n)=ad1(k,n)+fvn(i,j,k)
                          if (k == 1) then
                             aht(n)=aht(n)+fvnt(i,j,1)
                             asf(n)=asf(n)+fvnt(i,j,2)
                             ash(n)=ash(n)+fvnt(i,j,3)
                          end if
                       endif
                       if (imaskt(i,j) == 1.or.(smaskt(i,j)==1.and.tlon(i,j)> 20. .and.tlon(i,j) <= 145.)) then
                          it1(k,n)=it1(k,n)+fuet(i,j,k)
                          it2(k,n)=it2(k,n)+tarea(i,j)
                          is1(k,n)=is1(k,n)+fue(i,j,k)
                          id1(k,n)=id1(k,n)+fvn(i,j,k)
                          if (k == 1) then
                             iht(n)=iht(n)+fvnt(i,j,1)
                             isf(n)=isf(n)+fvnt(i,j,2)
                             ish(n)=ish(n)+fvnt(i,j,3)
                          end if
                       endif
                       if (pmaskt(i,j) == 1 .or. (smaskt(i,j)==1.and.(tlon(i,j) >145. .and. tlon(i,j) <= 290.))) then
                          pt1(k,n)=pt1(k,n)+fuet(i,j,k)
                          pt2(k,n)=pt2(k,n)+tarea(i,j)
                          ps1(k,n)=ps1(k,n)+fue(i,j,k)
                          pd1(k,n)=pd1(k,n)+fvn(i,j,k)
                          if (k == 1) then
                             pht(n)=pht(n)+fvnt(i,j,1)
                             psf(n)=psf(n)+fvnt(i,j,2)
                             psh(n)=psh(n)+fvnt(i,j,3)
                          end if
                       endif

                    endif
                 enddo ! do k=1,km
              endif

           enddo ! do i=1,imt
        enddo ! do j=1,jmt

        if (n.eq.200) print*,'asf(200)=',asf(200)
        if (gt2(1,n).gt.0.) then
           ght(n)=ght(n)/gt2(1,n)
           gsf(n)=gsf(n)/gt2(1,n)
           gsh(n)=gsh(n)/gt2(1,n)
        else
           ght(n)=1.e30
           gsf(n)=1.e30
           gsh(n)=1.e30
        end if
        if (at2(1,n).gt.0.) then
           aht(n)=aht(n)/at2(1,n)
           asf(n)=asf(n)/at2(1,n)
           ash(n)=ash(n)/at2(1,n)
        else
           aht(n)=1.e30
           asf(n)=1.e30
           ash(n)=1.e30
        end if
        if (it2(1,n).gt.0.) then
           iht(n)=iht(n)/it2(1,n)
           isf(n)=isf(n)/it2(1,n)
           ish(n)=ish(n)/it2(1,n)
        else
           iht(n)=1.e30
           isf(n)=1.e30
           ish(n)=1.e30
        end if
        if (pt2(1,n).gt.0.) then
           pht(n)=pht(n)/pt2(1,n)
           psf(n)=psf(n)/pt2(1,n)
           psh(n)=psh(n)/pt2(1,n)
        else
           pht(n)=1.e30
           psf(n)=1.e30
           psh(n)=1.e30
        end if
        areag=gt2(1,:)
        areaa=at2(1,:)
        areai=it2(1,:)
        areap=pt2(1,:)

        do k=1,km
           if (gt2(k,n).gt.0.) then
              gt1(k,n)=gt1(k,n)/gt2(k,n)
              gs1(k,n)=gs1(k,n)/gt2(k,n)
              gd1(k,n)=gd1(k,n)/gt2(k,n)
           else
              gt1(k,n)=1.e30
              gs1(k,n)=1.e30
              gd1(k,n)=1.e30
           end if
           if (at2(k,n).gt.0.) then
              at1(k,n)=at1(k,n)/at2(k,n)
              as1(k,n)=as1(k,n)/at2(k,n)
              ad1(k,n)=ad1(k,n)/at2(k,n)
           else
              at1(k,n)=1.e30
              as1(k,n)=1.e30
              ad1(k,n)=1.e30
           end if
           if (it2(k,n).gt.0.) then
              it1(k,n)=it1(k,n)/it2(k,n)
              is1(k,n)=is1(k,n)/it2(k,n)
              id1(k,n)=id1(k,n)/it2(k,n)
           else
              it1(k,n)=1.e30
              is1(k,n)=1.e30
              id1(k,n)=1.e30
           end if
           if (pt2(k,n).gt.0.) then
              pt1(k,n)=pt1(k,n)/pt2(k,n)
              ps1(k,n)=ps1(k,n)/pt2(k,n)
              pd1(k,n)=pd1(k,n)/pt2(k,n)
           else
              pt1(k,n)=1.e30
              ps1(k,n)=1.e30
              pd1(k,n)=1.e30
           end if

	end do
        if (nnn.le.10 .and.latr(n).gt.-75.5) then
           gt1(:,n)=gt1(:,n-1)
           gs1(:,n)=gs1(:,n-1)
           gd1(:,n)=gd1(:,n-1)
           at1(:,n)=at1(:,n-1)
           as1(:,n)=as1(:,n-1)
           ad1(:,n)=ad1(:,n-1)
           it1(:,n)=it1(:,n-1)
           is1(:,n)=is1(:,n-1)
           id1(:,n)=id1(:,n-1)
           pt1(:,n)=pt1(:,n-1)
           ps1(:,n)=ps1(:,n-1)
           pd1(:,n)=pd1(:,n-1)
           ght(n)=ght(n-1)
           aht(n)=aht(n-1)
           iht(n)=iht(n-1)
           pht(n)=pht(n-1)
           gsh(n)=gsh(n-1)
           ash(n)=ash(n-1)
           ish(n)=ish(n-1)
           psh(n)=psh(n-1)
           gsf(n)=gsf(n-1)
           asf(n)=asf(n-1)
           isf(n)=isf(n-1)
           psf(n)=psf(n-1)
           areag(n)=areag(n-1)
           areaa(n)=areaa(n-1)
           areai(n)=areai(n-1)
           areap(n)=areap(n-1)
        end if
        if (latr(n).gt.-17..and.latr(n).lt.-15.5) then
           gt1(:,n)=gt1(:,n-1)
           gs1(:,n)=gs1(:,n-1)
           gd1(:,n)=gd1(:,n-1)
           at1(:,n)=at1(:,n-1)
           as1(:,n)=as1(:,n-1)
           ad1(:,n)=ad1(:,n-1)
           it1(:,n)=it1(:,n-1)
           is1(:,n)=is1(:,n-1)
           id1(:,n)=id1(:,n-1)
           pt1(:,n)=pt1(:,n-1)
           ps1(:,n)=ps1(:,n-1)
           pd1(:,n)=pd1(:,n-1)
           ght(n)=ght(n-1)
           aht(n)=aht(n-1)
           iht(n)=iht(n-1)
           pht(n)=pht(n-1)
           gsh(n)=gsh(n-1)
           ash(n)=ash(n-1)
           ish(n)=ish(n-1)
           psh(n)=psh(n-1)
           gsf(n)=gsf(n-1)
           asf(n)=asf(n-1)
           isf(n)=isf(n-1)
           psf(n)=psf(n-1)
           areag(n)=areag(n-1)
           areaa(n)=areaa(n-1)
           areai(n)=areai(n-1)
           areap(n)=areap(n-1)
	end if
        if (jmt.eq.288.and.it1(1,n).gt.1.e10.and.latr(n).gt.2.) then
           it1(:,n)=it1(:,n-1)
           is1(:,n)=is1(:,n-1)
           id1(:,n)=id1(:,n-1)
           iht(n)=iht(n-1)
           ish(n)=ish(n-1)
           isf(n)=isf(n-1)
           areai(n)=areai(n-1)
        end if
     enddo ! do n=1,nphi

     print*,'asf(200)=',asf(200)
     ! Add variable data to netCDF file
     status = nf_inq_varid(tranncid,trim(varnam(3)),varid)
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     status = nf_put_vara_real(tranncid,varid,itime,1,time_pd(itime))
     if (status /= nf_noerr) write(*,*) nf_strerror(status)
     do l = 1,nv
        m = l+nd
        ostart(1) = 1 ; ocount(1) = nphi
        status = nf_inq_varid(tranncid,varnam(m),varid)
        if (vrdims(m) == 3) then
           ostart(2) = 1     ; ocount(2) =   km
           ostart(3) = itime ; ocount(3) =    1
        else
           ostart(2) = itime ; ocount(2) =    1
        endif
        !        if (vrdims(m) == 3) then
        !           ostart(1) = 1 ; ocount(1) = nphi
        !           ostart(2) = 1     ; ocount(2) =   km
        !           ostart(3) = itime ; ocount(3) =    1
        !        elseif (vrdims(m) == 2) then
        !           ostart(1) = 1 ; ocount(1) = nphi
        !           ostart(2) = itime ; ocount(2) =    1
        !        else
        !           ostart(1) = itime ; ocount(1) = 1
        !        endif

        select case (trim(varnam(m)))
        case ('gtemp')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(gt1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('atemp')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(at1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('itemp')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(it1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('ptemp')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(pt1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('gsalt')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(gs1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('asalt')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(as1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('isalt')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(is1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('psalt')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(ps1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('gdens')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(gd1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('adens')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(ad1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('idens')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(id1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('pdens')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,transpose(pd1))
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('gsht')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,ght)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('asht')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,aht)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('isht')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,iht)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('psht')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,pht)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('gsfwf')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,gsf)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('asfwf')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,asf)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('isfwf')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,isf)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('psfwf')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,psf)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('gssh')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,gsh)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('assh')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,ash)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('issh')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,ish)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('pssh')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,psh)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('areag')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,areag)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('areaa')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,areaa)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('areai')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,areai)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case ('areap')
           status = nf_put_vara_real(tranncid,varid,ostart,ocount,areap)
           if (status /= nf_noerr) write(*,*) nf_strerror(status)
        case default
           write(*,*) 'Cannot happen.'
        end select
     enddo
  enddo
  status = nf_close(tranncid)
end program poptrans
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine density(idm,jdm,tempp,salnp,den,kmt,klev,refp)
  integer idm,jdm,klev
  real tempp(idm,jdm),salnp(idm,jdm),ref_p
  integer kmt(idm,jdm)
  real den(idm,jdm)
  !===================================================================
  ! This program is used to calculate the density of each ocean grid
  ! point. Now the default is to calculate the potential density of
  ! the sea water -- sigma-0.
  ! The inputs are the dimensions of i, j, k direction, temperature
  ! and salinity, ocean grid mask (kmt). The outputs are density
  ! (sigma), temperature and salionity.
  !
  ! Coded by Aixue Hu, May 9, 2002.
  !
  ! input:
  !	idm -- i dimension of the input array
  !	jdm -- j dimension of the input array
  !	kmax -- k dimension of the input array
  !	tempp -- input potential temperature
  !	salnp -- input salinity (g/kg, or psu)
  !	kmt -- ocean depth file
  !	sigma -- output potential density
  !	ref_p -- reference pressure (decibars)
  !===================================================================

  integer i,j,k,lev
  real sigma(idm,jdm)


  ! --- calculate the potential density

  do j=1,jdm
     do i=1,idm
        if(kmt(i,j).ge.1.and.klev.le.kmt(i,j)) then
           call svannew(salnp(i,j),tempp(i,j),ref_p,sig0)
           den(i,j) = sig0
        else
           den(i,j) = 1.e30
        end if
     enddo
  enddo

  return
end subroutine density

!     subroutine dens(s,t,p0,sigma)

!     data c1,c2,c3,c4,c5,c6,c7/
!    . -1.36471E-01, 4.68181E-02, 8.07004E-01,-7.45353E-03,-2.94418E-03,
!    .  3.43570E-05, 3.48658E-05/
!
! --- sigma-theta as a function of temp (deg c) and salinity (mil)
! --- (friedrich-levitus 3rd degree polynomial fit)
!
!     sigma=(c1+c3*s+t*(c2+c5*s+t*(c4+c7*s+c6*t)))*1.e-3
!     return
!     end
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine svannew(s,t,p0,sigma)
  !*
  !* Specific Volume Anomaly (steric anomaly) based on 1980 equation
  !* of state for seawater and 1978 practical salinity scale.
  !* References:
  !*        millero, et al (1980) deep-sea res.,27a,255-264
  !*        millero and poisson 1981,deep-sea res.,28a pp 625-629.
  !*   (both  references are also found in unesco report 38 -- 1981)
  !* ................................................................
  !*  The type of density anomaly (sigma) computed depends on the type of
  !*  temperature and pressure supplied:
  !*
  !*   in situ density:  t is in situ temperature
  !*                     p0 is in situ pressure
  !*
  !*   potential density: p0 is reference pressure
  !*                      t is temperature referenced already to p0
  !*
  !*   sigma-t: : p0 = 0
  !*              t is in situ temperature
  !* ................................................................
  !* units:
  !*       p0  :    pressure  [or ref pressure] (decibars)
  !*        t  :    temperature  [or pot temp]  (deg C)
  !*        s  :    salinity (ipss-78)
  !*     svan  :    spec. vol. anom.  (m**3/kg *1.0e-8)
  !*     sigma :    density anomaly   (kg/m**3)
  !* ................................................................
  !* check value: svan=981.3021 e-8 m**3/kg.  for s = 40 (ipss-78) ,
  !* t = 40 deg c, p0= 10000 decibars.
  !* check value: sigma = 59.82037  kg/m**3 for s = 40 (ipss-78) ,
  !* t = 40 deg c, p0= 10000 decibars.
  !* ................................................................
  !      implicit real*8 (a-h,o-z)

  real p,t,s,sig,sr,r1,r2,r3,r4
  real a,b,c,d,e,a1,b1,aw,bw,k,k0,kw,k35
  !*
  equivalence (e,d,b1), (bw,b,r3), (c,a1,r2)
  equivalence (aw,a,r1),(kw,k0,k)
  !*
  !      data r3500 /1028.1063/
  !      data r4 /4.8314e-4/    ! referred to as C in millero and poisson 1981
  !      data dr350 /28.106331/
  r3500=1028.1063
  r4   =4.8314e-4
  dr350=28.106331
  !*
  !*
  !* convert pressure to bars and take square root of salinity.
  !*
  p = p0 / 10.
  sr = sqrt(abs(s))
  !*
  !* pure water density at atmospheric pressure
  !*   bigg p.h.,(1967) br. j. applied physics 8 pp 521-537.
  !*
  r1 = ((((6.536332e-9*t-1.120083e-6)*t+1.001685e-4)*t &
       &      -9.095290e-3)*t+6.793952e-2)*t-28.263737
  !*
  !* seawater density at atmospheric press.
  !*    coefficients involving salinity:
  !*      r2 = A   in notation of millero and poisson 1981
  !*      r3 = B
  !*
  r2 = (((5.3875e-9*t-8.2467e-7)*t+7.6438e-5)*t-4.0899e-3)*t&
       &     +8.24493e-1
  !*
  r3 = (-1.6546e-6*t+1.0227e-4)*t-5.72466e-3
  !*
  !*  international one-atmosphere equation of state of seawater
  !*
  sig = (r4*s + r3*sr + r2)*s + r1
  !*
  !*  specific volume at atmospheric pressure
  !*
  v350p = 1.0 / r3500
  sva = -sig * v350p / (r3500+sig)
  sigma = sig + dr350
  !*
  !*  scale specific vol. anomaly to normally reported units
  !*
  svan = sva * 1.0e+8
  !*      svan = sva * 1.0e+7 !+8 crash out put
  if (p.eq.0.) return
  !*
  !* ............................................................
  !      high pressure equation of state for seawater
  !        millero, et al , 1980 dsr 27a, pp 255-264
  !               constant notation follows article
  !* ............................................................
  !* compute compression terms ...
  !*
  e = (9.1697e-10*t+2.0816e-8)*t-9.9348e-7
  bw = (5.2787e-8*t-6.12293e-6)*t+3.47718e-5
  b = bw + e * s
  !*
  d = 1.91075e-4
  c = (-1.6078e-6*t-1.0981e-5)*t+2.2838e-3
  aw = ((-5.77905e-7*t+1.16092e-4)*t+1.43713e-3)*t &
       &      -0.1194975
  a = (d * sr + c) * s + aw
  !*
  b1 = (-5.3009e-4*t+1.6483e-2)*t+7.944e-2
  a1 = ((-6.1670e-5*t+1.09987e-2)*t-0.603459)*t+54.6746
  kw = (((-5.155288e-5*t+1.360477e-2)*t-2.327105)*t &
       &      +148.4206)*t-1930.06
  k0 = (b1*sr + a1)*s + kw
  !*
  !* evaluate pressure polynomial
  !* ............................................................
  !c   k equals the secant bulk modulus of seawater
  !   dk = k(s,t,p) - k(35,0,p)
  !   k35 = k(35,0,p)
  !* ............................................................
  dk = (b * p + a) * p + k0
  k35 = (5.03217e-5*p+3.359406)*p+21582.27
  gam = p / k35
  pk = 1.0 - gam
  sva = sva*pk + (v350p+sva)*p*dk/(k35*(k35+dk))
  !*
  !*  scale specific vol. anamoly to normally reported units...
  !*
  svan = sva*1.0e+8
  !*      svan = sva*1.0e+7 !if +8 the out put crash because I/O format
  v350p = v350p * pk
  !* ....................................................................
  !* compute density anamoly with respect to 1000.0 kg/m**3
  !*  1) dr350: density anomaly at 35 (ipss-78), 0 deg. c and 0 decibars
  !*  2) dr35p: density anomaly 35 (ipss-78), 0 deg. c ,  pres. variation
  !*  3) dvan : density anomaly variations involving specfic vol. anamoly
  !* ....................................................................
  dr35p = gam / v350p
  dvan = sva / (v350p * (v350p+sva))
  sigma = dr350 + dr35p - dvan
  !*
  return
end subroutine svannew
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
subroutine check_exists(file)
  !
  ! Check and make sure 'file' exists
  !
  character(len=*),intent(in)::file
  !
  logical::exists
  !
  inquire(file=trim(file),exist=exists)
  if (.not.(exists)) then
     write(*,'(a,'' not found. STOP.'')') trim(file)
     call abort()
  endif
end subroutine check_exists

subroutine handle_err(status)
  !
  implicit none
  include 'netcdf.inc'
  !
  integer::status
  if (status /= nf_noerr) then
     print *, nf_strerror(status)
     call abort()
  endif
  !
  return
end subroutine handle_err

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

      module kinds_mod

!BOP
! !MODULE: kinds_mod
!
! !DESCRIPTION:
!  This module defines default numerical data types for all common data
!  types like integer, character, logical, real4 and real8.
!
! !REVISION HISTORY:
!  CVS:$Id: kinds_mod.F90,v 1.7 2002/12/11 17:28:16 pwjones Exp $
!  CVS:$Name:  $

! !USES:
!  uses no other modules

        implicit none
   	private
   	save

! !DEFINED PARAMETERS:

   	integer, parameter, public ::  char_len  = 100      ,&
      log_kind  = kind(.true.)           ,&
      int_kind  = kind(1)                ,&
      i4        = selected_int_kind(6)   ,&
      i8        = selected_int_kind(13)  ,&
      r4        = selected_real_kind(6)  ,&
      r8        = selected_real_kind(13) ,&
      real_kind = selected_real_kind(6),  &
      dbl_kind  = selected_real_kind(13)



!EOP
!BOC
!EOC
!***********************************************************************

 end module kinds_mod

!|||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||

      subroutine density(idm,jdm,tempp,salnp,den,kmt,klev,refp)
      integer idm,jdm,klev
      real tempp(idm,jdm),salnp(idm,jdm),ref_p
      integer kmt(idm,jdm)
      real den(idm,jdm)
!===================================================================
! This program is used to calculate the density of each ocean grid
! point. Now the default is to calculate the potential density of
! the sea water -- sigma-0.
! The inputs are the dimensions of i, j, k direction, temperature
! and salinity, ocean grid mask (kmt). The outputs are density
! (sigma), temperature and salionity.
!
! Coded by Aixue Hu, May 9, 2002.
!
! input:
!	idm -- i dimension of the input array
!	jdm -- j dimension of the input array
!	kmax -- k dimension of the input array
!	tempp -- input potential temperature
!	salnp -- input salinity (g/kg, or psu)
!	kmt -- ocean depth file
!	sigma -- output potential density
!	ref_p -- reference pressure (decibars)
!===================================================================

      integer i,j,k,lev
      real sigma(idm,jdm)


! --- calculate the potential density

      do j=1,jdm
      do i=1,idm
       if(kmt(i,j).ge.1.and.klev.le.kmt(i,j)) then
             call svannew(salnp(i,j),tempp(i,j),ref_p,sig0)
             den(i,j) = sig0
       else
             den(i,j) = 1.e30
       end if
      enddo
      enddo

      return
      end
